<?php

/**
 * Plugin Name: Bulk Mail Sender Pro
 * Plugin URI: https://insixus.com
 * Description: Bulk Mail Sender Pro is an add on with extended feature for Bulk Mail Sender plugin.
 * Version: 1.0.0
 * Author: InSixUs InfoTech
 * Text Domain: bulk-mail-sender-pro
 * Domain Path: /languages
 * Author URI: http://insixus.com/
 **/

use ProApp\baseClasses\BMSIProActivate;
use ProApp\baseClasses\BMSIProBase;
use ProApp\baseClasses\BMSIProDeactivate;
use ProApp\baseClasses\BMSIProAdmin;

defined('ABSPATH') or die('Something went wrong');

ini_set('display_errors', 0);

// Require once the Composer Autoload
if (file_exists(dirname(__FILE__) . '/vendor/autoload.php')) {
    require_once dirname(__FILE__) . '/vendor/autoload.php';
} else {
    die('Autoload file not found');
}

if (!defined('BMSI_PRO_DIR_PATH')) {
    define('BMSI_PRO_DIR_PATH', plugin_dir_path(__FILE__));
}

if (!defined('BMSI_PRO_NAMESPACE')) {
    define('BMSI_PRO_NAMESPACE', "bmsi-pro");
}

if (!defined('BMSI_PRO_REQUIRED_PLUGIN_VERSION')) {
    define('BMSI_PRO_REQUIRED_PLUGIN_VERSION', '1.0.0');
}

if (!defined('BMSI_PRO_DIR_URI')) {
    define('BMSI_PRO_DIR_URI', plugin_dir_url(__FILE__));
}

if (!defined('BMSI_PRO_PLUGIN_BASENAME')) {
    define('BMSI_PRO_PLUGIN_BASENAME', plugin_basename(__FILE__));
}

function bmsi_pro_add_custom_post_type()
{
    $labels = array(
        'name' => 'BMSI_Pro_Templates',
        'singular_name' => 'BMSI_Pro_Templates',
        'add_new' => esc_html__('Add New', 'BMSI_Pro_Templates'),
    );

    $args = array(
        'labels' => $labels,
        'public' => true,
        'has_archive' => true,
        'rewrite' => array('slug' => 'BMSI_Pro_Templates'),
        'supports' => array('title', 'editor', 'thumbnail', 'revisions'),
        'show_ui' => false,
    );

    register_post_type('BMSI_Pro_Templates', $args);

    add_post_type_support('BMSI_Pro_Templates', 'thumbnail');

    add_theme_support('post-thumbnails');
    add_theme_support('post-thumbnails', array('post', 'page', 'popup'));
    add_post_type_support('BMSI_Pro_Templates', 'thumbnail');
}

add_action('init', 'bmsi_pro_add_custom_post_type', 0);

// The code that runs during plugin activation
register_activation_hook(__FILE__, [BMSIProActivate::class, 'activate']);

// The code that runs during plugin deactivation
register_deactivation_hook(__FILE__, [BMSIProDeactivate::class, 'init']);

// Initialize the plugin
(new BMSIProActivate())->init();
(new BMSIProAdmin());
(new BMSIProBase());
