<?php
namespace ProApp\baseClasses;

use PhpOffice\PhpSpreadsheet\IOFactory;

class BMSIProAdmin extends BMSIProBase
{
    public function __construct()
    {
        add_action('admin_enqueue_scripts', [$this, 'bmsi_admin_enqueue_scripts']);
        add_action('wp_ajax_BMSI_create_new_template', [$this, "BMSI_create_new_template_callback"]);
        add_action('wp_ajax_nopriv_BMSI_create_new_template', [$this, "BMSI_create_new_template_callback"]);
        add_action('wp_ajax_BMSI_delete_category', [$this, "BMSI_delete_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_delete_category', [$this, "BMSI_delete_category_callback"]);
        add_action('wp_ajax_BMSI_delete_sub_category', [$this, "BMSI_delete_sub_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_delete_sub_category', [$this, "BMSI_delete_sub_category_callback"]);
        add_action('wp_ajax_BMSI_display_newsletters_category', [$this, "BMSI_display_newsletters_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_display_newsletters_category', [$this, "BMSI_display_newsletters_category_callback"]);
        add_action('wp_ajax_BMSI_display_newsletters_tag', [$this, "BMSI_display_newsletters_tag_callback"]);
        add_action('wp_ajax_nopriv_BMSI_display_newsletters_tag', [$this, "BMSI_display_newsletters_tag_callback"]);
        add_action('wp_ajax_BMSI_delete_tag', [$this, "BMSI_delete_tag_callback"]);
        add_action('wp_ajax_nopriv_BMSI_delete_tag', [$this, "BMSI_delete_tag_callback"]);
        add_action('wp_ajax_BMSI_add_new_tag', [$this, "BMSI_add_new_tag_callback"]);
        add_action('wp_ajax_nopriv_BMSI_add_new_tag', [$this, "BMSI_add_new_tag_callback"]);
        add_action('wp_ajax_BMSI_fetch_tags', [$this, "BMSI_fetch_tags_callback"]);
        add_action('wp_ajax_nopriv_BMSI_fetch_tags', [$this, "BMSI_fetch_tags_callback"]);
        add_action('wp_ajax_BMSI_delete_template', [$this, "BMSI_delete_template_callback"]);
        add_action('wp_ajax_nopriv_BMSI_delete_template', [$this, "BMSI_delete_template_callback"]);
        add_action('wp_ajax_BMSI_display_template', [$this, "BMSI_display_template_callback"]);
        add_action('wp_ajax_nopriv_BMSI_display_template', [$this, "BMSI_display_template_callback"]);
        add_shortcode('BMSI_News_Letter', [$this, "BMSI_news_letter_form_shortcode"]);
        add_action('wp_ajax_BMSI_handle_news_letter_form', [$this, "BMSI_handle_news_letter_form_callback"]);
        add_action('wp_ajax_nopriv_BMSI_handle_news_letter_form', [$this, "BMSI_handle_news_letter_form_callback"]);
        add_action('wp_ajax_BMSI_display_email', [$this, "BMSI_display_email_callback"]);
        add_action('wp_ajax_nopriv_BMSI_display_email', [$this, "BMSI_display_email_callback"]);
        add_action('wp_ajax_BMSI_chart_details', [$this, "BMSI_chart_details_callback"]);
        add_action('wp_ajax_nopriv_BMSI_chart_details', [$this, "BMSI_chart_details_callback"]);
        add_action('wp_ajax_BMSI_pro_display_history', [$this, "BMSI_pro_display_history_callback"]);
        add_action('wp_ajax_nopriv_BMSI_pro_display_history', [$this, "BMSI_pro_display_history_callback"]);
        add_action('wp_ajax_BMSI_view_record_history_pro', [$this, "BMSI_view_record_history_pro_callback"]);
        add_action('wp_ajax_nopriv_BMSI_view_record_history_pro', [$this, "BMSI_view_record_history_pro_callback"]);
        add_action('wp_ajax_BMSI_add_new_category', [$this, "BMSI_add_new_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_add_new_category', [$this, "BMSI_add_new_category_callback"]);
        add_action('wp_ajax_BMSI_news_letter_record', [$this, "BMSI_news_letter_record_callback"]);
        add_action('wp_ajax_nopriv_BMSI_news_letter_record', [$this, "BMSI_news_letter_record_callback"]);
        add_action('wp_ajax_BMSI_add_news_letter_user_category', [$this, "BMSI_add_news_letter_user_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_add_news_letter_user_category', [$this, "BMSI_add_news_letter_user_category_callback"]);
        add_action('wp_ajax_BMSI_delete_news_letter_email', [$this, "BMSI_delete_news_letter_email_callback"]);
        add_action('wp_ajax_nopriv_BMSI_delete_news_letter_email', [$this, "BMSI_delete_news_letter_email_callback"]);
        add_action('wp_ajax_BMSI_edit_news_letter_user_category', [$this, "BMSI_edit_news_letter_user_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_edit_news_letter_user_category', [$this, "BMSI_edit_news_letter_user_category_callback"]);
        add_action('wp_ajax_save_activation_key', [$this, "save_activation_key_callback"]);
        add_action('wp_ajax_nopriv_save_activation_key', [$this, "save_activation_key_callback"]);
        add_action('wp_ajax_BMSI_fetch_categories_and_subcategories', [$this, "BMSI_fetch_categories_and_subcategories_callback"]);
        add_action('wp_ajax_nopriv_BMSI_fetch_categories_and_subcategories', [$this, "BMSI_fetch_categories_and_subcategories_callback"]);
        add_action('wp_ajax_BMSI_get_sub_categories', [$this, "BMSI_get_sub_categories_callback"]);
        add_action('wp_ajax_nopriv_BMSI_get_sub_categories', [$this, "BMSI_get_sub_categories_callback"]);
        add_filter('additional_tab_links', [$this, 'add_new_tab_link']);
        add_filter('additional_tab_contents', [$this, 'render_settings_page']);
        add_action('wp_ajax_BMSI_Import_newsletter_email', [$this, "BMSI_Import_newsletter_email_callback"]);
        add_action('wp_ajax_nopriv_BMSI_Import_newsletter_email', [$this, "BMSI_Import_newsletter_email_callback"]);
        add_action('wp_ajax_BMSI_Import_newsletter_email_columnlist', [$this, "BMSI_Import_newsletter_email_columnlist_callback"]);
        add_action('wp_ajax_nopriv_BMSI_Import_newsletter_email_columnlist', [$this, "BMSI_Import_newsletter_email_columnlist_callback"]);
        add_action('wp_ajax_BMSI_Import_newsletter_category', [$this, "BMSI_Import_newsletter_category_callback"]);
        add_action('wp_ajax_nopriv_BMSI_Import_newsletter_category', [$this, "BMSI_Import_newsletter_category_callback"]);
    }

    public function add_new_tab_link($content)
    {
        $content .= '<p class="tab-links" data-tab="tab5">Activaion Key</p>';
        return $content;
    }

    public static function render_settings_page($content)
    {
        ob_start();
        ?>
        <div class="tab-contents" id="tab5">
            <div class="note">
                <form method="post" class="BMSI_pro_activation_form">
                    <?php $nonce = wp_create_nonce('smtp_nonce'); ?>
                    <input type="hidden" id="BMSI_PRO_nonce" name="BMSI_PRO_nonce" value="<?php echo esc_attr($nonce); ?>" />
            </div>
            <div class="firstAndLastName">
                <div class="d-flex flex-column gap-2 w-50">

                    <label for="activation-key">Activaion Key</label>
                    <input class="input-groups" type="text" name="activation_key" id="activation_key"
                        value="<?php echo esc_attr(get_option('BMSI_PRO_key')); ?>" class="regular-text" required />
                    <?php if (!get_option('BMIS_Pro_activated')) {

                        ?>
                        <p style="color:red;" class="mb-0">
                            <?php _e('*Activation key is invalid or there was an error verifying it.', 'BMIS_Pro_activated'); ?>
                        </p>
                        <p><?php printf(__('To get your activation key, <a href="%s" target="_blank">click here</a>.', 'BMIS_Pro_activated'), esc_url('https://bulkmail.insixus.com/my-account/activation-key/')); ?>
                        </p>
                    <?php } ?>
                    <?php if (get_option('BMIS_Pro_activated')) { ?>
                        <p style="color:green;"><?php _e('*Activation key is valid.', 'BMIS_Pro_activated'); ?></p>
                    <?php } ?>
                </div>
            </div>
            <div class="d-flex w-100 justify-content-start save-button">
                <button type="submit" name="submit-sub" id="submit" class="add-button fs-16menu border-0 btn-submit-key">
                    <span class="btn-txt">Save Activaion Key</span><i class="fa-solid fa-spinner spinn"></i>
                </button>
            </div>

            </form>
        </div>
        </div>

        <?php
        $content .= ob_get_clean();
        return $content;
    }

    public function save_activation_key_callback()
    {
        if (!isset($_POST['BMSI_PRO_nonce']) || !wp_verify_nonce($_POST['BMSI_PRO_nonce'], 'ajax-nonce')) {
            wp_die('Invalid nonce.');
        }

        if (!current_user_can('manage_options')) {
            wp_die('Unauthorized user');
        }
        if (isset($_POST['activation_key'])) {
            $activation_key = sanitize_text_field($_POST['activation_key']);
            update_option('BMSI_PRO_key', $activation_key);

            $domain = get_site_url();
            $api_url = "https://bulkmail.insixus.com/wp-json/insixus/v1/activation-key";

            $api_data = array(
                'domain' => $domain,
                'key' => $activation_key
            );

            $response_api = wp_remote_post(
                $api_url,
                array(
                    'method' => 'POST',
                    'body' => wp_json_encode($api_data),
                    'headers' => array(
                        'Content-Type' => 'application/json',
                    ),
                    'timeout' => 20
                )
            );

            $response_code = wp_remote_retrieve_response_code($response_api);
            $body = wp_remote_retrieve_body($response_api);
            $result = json_decode($body, true);

            if ($response_code == 200 && isset($result['status']) && $result['status'] == 'valid') {
                update_option('BMIS_Pro_activated', true);
                $response = [
                    'status' => true,
                ];

            } else {
                update_option('BMIS_Pro_activated', false);
                $response = [
                    'status' => false,
                ];

            }
        } else {

            update_option('BMIS_Pro_activated', false);
            $response = [
                'status' => false,
            ];

        }

        header('Content-Type: application/json');
        echo json_encode($response);
        wp_die();
    }

    public function bmsi_admin_enqueue_scripts()
    {
        global $pagenow;
        if ($pagenow == "admin.php") {
            if (in_array($_GET['page'], ["users", "create_user", "send_mail", "history", "newsletter", "newsletter_category", "newsletter_tags", "bulk_mail_sender", "settings", "templates", "create_template"])) {
                wp_enqueue_script('bmsi_pro_admin_js', BMSI_PRO_DIR_URI . 'assets/js/pro_admin_script.js', ['jquery'], '1.0.0', true);
                wp_enqueue_script('datatables-script', BMSI_DIR_URI . 'assets/js/jquery.dataTables.min.js', array('jquery'), '1.10.25', true);
                wp_enqueue_script('btn-js', BMSI_DIR_URI . 'assets/js/dataTables.buttons.min.js', array('datatables'), '1.7.1', true);
                wp_enqueue_style('datatables-style', BMSI_DIR_URI . 'assets/css/jquery.dataTables.min.css', '1.1.3');
                wp_enqueue_style('btn-css', BMSI_DIR_URI . 'assets/css/buttons.dataTables.min.css', '1.1.3');


                wp_enqueue_script('multiselect_js', BMSI_PRO_DIR_URI . 'assets/js/multiselect.min.js', ['jquery'], '1.0.0', true);
                wp_enqueue_style('multiselect_css', BMSI_PRO_DIR_URI . 'assets/css/multiselect.css', '1.0.0');
            }
            if (isset($_GET['page']) && in_array($_GET['page'], ["bulk_mail_sender"])) {
                if (get_option('BMIS_Pro_activated')) {
                    wp_enqueue_script('custom-chart-js', BMSI_PRO_DIR_URI . 'assets/js/custom-chart.js');
                }
            }
        }
    }

    public function BMSI_create_new_template_callback()
    {

        $edit_id = isset($_POST['edit_id']) ? sanitize_text_field($_POST['edit_id']) : "";
        $edit_permission = isset($_POST['edit_permission']) ? sanitize_text_field($_POST['edit_permission']) : "";
        $subject = isset($_POST['mail_sub']) ? sanitize_text_field($_POST['mail_sub']) : "";
        $mail_from_name = isset($_POST['mail_from']) ? sanitize_text_field($_POST['mail_from']) : "";
        $mail_from_email = isset($_POST['admin_mail']) ? sanitize_text_field($_POST['admin_mail']) : "";
        $t_name = isset($_POST['template_name']) ? sanitize_text_field($_POST['template_name']) : "";

        $args = array(
            'post_type' => 'BMSI_Pro_Templates',
            'title' => $t_name,
            'posts_per_page' => 1,
        );

        $templates = get_posts($args);

        if (empty($templates)) {

            $add_post = array(
                'post_title' => $t_name,
                'post_content' => isset($_POST['email_body']) ? wp_kses_post($_POST['email_body']) : "",
                'post_type' => 'BMSI_Pro_Templates',
                'post_status' => 'publish'
            );

            if ($edit_permission == "true") {
                $add_post['ID'] = $edit_id;
                $add_post['post_name'] = $t_name;
                $post_id = wp_update_post($add_post);

                update_post_meta($post_id, 'template_subject', $subject, true);
                update_post_meta($post_id, 'mail_from_name', $mail_from_name, true);
                update_post_meta($post_id, 'mail_from_email', $mail_from_email, true);
                
                $message = "Template Updated Successfully";
                $title = "Updated!";

                $response = [
                    'status' => true,
                    'message' => esc_html($message, 'bulk-mail'),
                    'title' => esc_html($title, 'bulk-mail'),

                ];

            } else {
                $post_id = wp_insert_post($add_post);

                if ($post_id) {
                    add_post_meta($post_id, 'template_subject', $subject, true);
                    add_post_meta($post_id, 'mail_from_name', $mail_from_name, true);
                    add_post_meta($post_id, 'mail_from_email', $mail_from_email, true);
                    $message = "Template Created Successfully.";
                    $title = "Created!";

                    $response = [
                        'status' => true,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),

                    ];
                } else {
                    $message = "Something Went Wrong.";
                    $title = "Alert!";
                    $response = [
                        'status' => false,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),
                    ];
                }
            }

        } else {
            $message = "Template Alredy Exists.";
            $title = "Alert!";
            $response = [
                'status' => false,
                'title' => esc_html($title, 'bulk-mail'),
                'message' => esc_html($message, 'bulk-mail'),
            ];
        }

        header('Content-Type: application/json');
        echo json_encode($response);
        wp_die();
    }

    public function BMSI_display_template_callback()
    {
        if (!isset($_POST['template_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['template_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }
        
        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;
        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;
        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";
        
        global $wpdb;
        $table_design = $wpdb->prefix . 'bmsi_design_template';
        
        // Fetch all parent categories
        $all_design_query = "SELECT * FROM {$table_design}";
        $search_term = '';
        
        if (!empty($search)) {
            $search_term = '%' . $wpdb->esc_like($search) . '%';
            $all_design_query .= $wpdb->prepare(" WHERE name LIKE %s", $search_term);
        }
        
        $all_design_query .= " ORDER BY id DESC LIMIT %d, %d";
        $all_design_query = $wpdb->prepare($all_design_query, $start, $length);
        $template_data = $wpdb->get_results($all_design_query);
        
        // Get the total number of records
        $count_query = "SELECT COUNT(*) FROM {$table_design}";
        if (!empty($search)) {
            $count_query .= $wpdb->prepare(" WHERE name LIKE %s", $search_term);
        }
        $count = $wpdb->get_var($count_query);
        
        // Prepare response
        $response = [
            'draw' => intval($_POST['draw']),
            'recordsTotal' => intval($count),  // Ensure it's an integer
            'recordsFiltered' => intval($count),  // Ensure it's an integer
            'data' => !empty($template_data) ? $template_data : [],
        ];
        
        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
        
    }

    public function BMSI_delete_category_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        global $wpdb;

        $table = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';
        $email_table = $wpdb->prefix . 'bmsi_news_letters_email';

        $id = !empty($_POST["id"]) ? intval($_POST["id"]) : "";
        $delete_option = isset($_POST['delete_option']) ? sanitize_text_field($_POST['delete_option']) : "";

        $category = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table WHERE id = %d", $id));
        $user_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM $email_table WHERE category = %d", $id));

        $uncategory = $wpdb->get_results($wpdb->prepare("SELECT id FROM $table WHERE category_name = %s", "uncategory"));
        $subuncategory = $wpdb->get_results($wpdb->prepare("SELECT id FROM $table_sub_category WHERE sub_category_name = %s", "uncategory"));

        if ($delete_option == "option1") {
            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    $wpdb->query($wpdb->prepare("DELETE FROM $email_table WHERE category = %d", $id));
                }
            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table_sub_category WHERE parent_category_id = %d", $id));
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table WHERE id = %d", $id));

        } elseif ($delete_option == "option2") {
            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    $wpdb->query($wpdb->prepare("UPDATE $email_table SET category = %d, sub_category = %d WHERE id = %d", $uncategory->id, $subuncategory->id, $value->id));
                }
            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table_sub_category WHERE parent_category_id = %d", $id));
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table WHERE id = %d", $id));

        } else {
            if (!empty($category)) {

                $parent_id = isset($_POST['parentselectedCategory']) ? sanitize_text_field($_POST['parentselectedCategory']) : "";

                $sub_id = isset($_POST['subselectedCategory']) ? sanitize_text_field($_POST['subselectedCategory']) : "";

                if (!empty($parent_id)) {
                    $is_parent_category = true;
                    $parent_category_id = $parent_id;
                } else {
                    $category_data = $wpdb->get_results($wpdb->prepare("SELECT parent_category_id FROM $table_sub_category WHERE id = %d", $sub_id));

                    if (!empty($category_data)) {
                        $is_parent_category = false;
                        $parent_category_id = $category_data[0]->parent_category_id;
                    } else {
                        $response = [
                            'status' => false,
                            'title' => esc_html("Error", 'bulk-mail'),
                            'message' => esc_html("Selected category not found.", 'bulk-mail'),
                        ];
                        header('Content-Type: application/json');
                        echo wp_json_encode($response);
                        wp_die();
                    }
                }
            } else {
                $response = [
                    'status' => true,
                    'title' => esc_html("Alert!", 'bulk-mail'),
                    'message' => esc_html("Category not found.", 'bulk-mail'),
                ];
            }

            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    if ($is_parent_category) {
                        $wpdb->query($wpdb->prepare("UPDATE $email_table SET category = %d, sub_category = %s WHERE id = %d", $parent_category_id, Null, $value->id));
                    } else {
                        $wpdb->query($wpdb->prepare("UPDATE $email_table SET category = %d, sub_category = %d WHERE id = %d", $parent_category_id, $sub_id, $value->id));
                    }
                }

            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table_sub_category WHERE parent_category_id = %d", $id));
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table WHERE id = %d", $id));

        }

        if ($result > 0) {
            $response = [
                'status' => true,
                'title' => esc_html("Congratulations!", 'bulk-mail'),
                'message' => esc_html("Category Deleted Successfully.", 'bulk-mail'),
            ];
        } else {
            $response = [
                'status' => true,
                'title' => esc_html("Alert!", 'bulk-mail'),
                'message' => esc_html("Something Went Wrong.", 'bulk-mail'),
            ];
        }


        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();


    }

    public function BMSI_delete_tag_callback()
    {
        if (!isset($_POST['news_letter_tag_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_tag_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        global $wpdb;

        $table = $wpdb->prefix . 'bmsi_news_letter_tag';
        $email_table = $wpdb->prefix . 'bmsi_news_letters_email';

        $id = !empty($_POST["id"]) ? intval($_POST["id"]) : "";
        $delete_option = isset($_POST['delete_option']) ? sanitize_text_field($_POST['delete_option']) : "";

        $category = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table WHERE id = %d", $id));
        $user_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM $email_table WHERE category = %d", $id));

        $uncategory = $wpdb->get_results($wpdb->prepare("SELECT id FROM $table WHERE category_name = %s", "uncategory"));

        if ($delete_option == "option1") {
            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    $wpdb->query($wpdb->prepare("DELETE FROM $email_table WHERE category = %d", $id));
                }
            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table WHERE id = %d", $id));

        } else {
            if (!empty($category)) {

                $parent_id = isset($_POST['parentselectedCategory']) ? sanitize_text_field($_POST['parentselectedCategory']) : "";

                $sub_id = isset($_POST['subselectedCategory']) ? sanitize_text_field($_POST['subselectedCategory']) : "";

                if (!empty($parent_id)) {
                    $is_parent_tag = true;
                    $parent_tag_id = $parent_id;
                } 
            } else {
                $response = [
                    'status' => true,
                    'title' => esc_html("Alert!", 'bulk-mail'),
                    'message' => esc_html("Tag not found.", 'bulk-mail'),
                ];
            }

            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table WHERE id = %d", $id));

        }

        if ($result > 0) {
            $response = [
                'status' => true,
                'title' => esc_html("Congratulations!", 'bulk-mail'),
                'message' => esc_html("Tag Deleted Successfully.", 'bulk-mail'),
            ];
        } else {
            $response = [
                'status' => true,
                'title' => esc_html("Alert!", 'bulk-mail'),
                'message' => esc_html("Something Went Wrong.", 'bulk-mail'),
            ];
        }


        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();


    }

    public function BMSI_delete_sub_category_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        global $wpdb;

        $table = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';
        $email_table = $wpdb->prefix . 'bmsi_news_letters_email';

        $id = !empty($_POST["id"]) ? intval($_POST["id"]) : "";

        $delete_option = isset($_POST['delete_option']) ? sanitize_text_field($_POST['delete_option']) : "";

        $sub_category = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_sub_category WHERE id = %d", $id));

        $user_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM $email_table WHERE sub_category = %d", $id));

        $uncategory = $wpdb->get_results($wpdb->prepare("SELECT id FROM $table WHERE category_name = %s", "uncategory"));
        $subuncategory = $wpdb->get_results($wpdb->prepare("SELECT id FROM $table_sub_category WHERE sub_category_name = %s", "uncategory"));

        if ($delete_option == "option1") {
            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    $wpdb->query($wpdb->prepare("DELETE FROM $email_table WHERE sub_category = %d", $id));
                }
            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table_sub_category WHERE id = %d", $id));

        } elseif ($delete_option == "option2") {
            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    $wpdb->query($wpdb->prepare("UPDATE $email_table SET category = %d, sub_category = %d WHERE id = %d", $uncategory->id, $subuncategory->id, $value->id));
                }
            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table_sub_category WHERE id = %d", $id));

        } else {

            if (!empty($sub_category)) {
                $parent_id = isset($_POST['parentselectedCategory']) ? sanitize_text_field($_POST['parentselectedCategory']) : "";

                $sub_id = isset($_POST['subselectedCategory']) ? sanitize_text_field($_POST['subselectedCategory']) : "";

                if (!empty($parent_id)) {
                    $is_parent_category = true;
                    $parent_category_id = $parent_id;
                } else {
                    $category_data = $wpdb->get_results($wpdb->prepare("SELECT parent_category_id FROM $table_sub_category WHERE id = %d", $sub_id));

                    if (!empty($category_data)) {
                        $is_parent_category = false;
                        $parent_category_id = $category_data[0]->parent_category_id;
                    } else {
                        $response = [
                            'status' => false,
                            'title' => esc_html("Error", 'bulk-mail'),
                            'message' => esc_html("Selected category not found.", 'bulk-mail'),
                        ];
                        header('Content-Type: application/json');
                        echo wp_json_encode($response);
                        wp_die();
                    }

                }
            } else {
                $response = [
                    'status' => true,
                    'title' => esc_html("Alert!", 'bulk-mail'),
                    'message' => esc_html("Category not found.", 'bulk-mail'),
                ];
            }


            if (!empty($user_data)) {
                foreach ($user_data as $value) {
                    if ($is_parent_category) {
                        $wpdb->query($wpdb->prepare("UPDATE $email_table SET category = %d, sub_category = %s WHERE id = %d", $parent_category_id, Null, $value->id));
                    } else {
                        $wpdb->query($wpdb->prepare("UPDATE $email_table SET category = %d, sub_category = %d WHERE id = %d", $parent_category_id, $sub_id, $value->id));
                    }
                }

            }
            $result = $wpdb->query($wpdb->prepare("DELETE FROM $table_sub_category WHERE id = %d", $id));

        }

        if ($result > 0) {
            $response = [
                'status' => true,
                'title' => esc_html("Congratulations!", 'bulk-mail'),
                'message' => esc_html("Category Deleted Successfully.", 'bulk-mail'),
            ];
        } else {
            $response = [
                'status' => true,
                'title' => esc_html("Alert!", 'bulk-mail'),
                'message' => esc_html("Something Went Wrong.", 'bulk-mail'),
            ];
        }


        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }


    public function BMSI_display_newsletters_category_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;
        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;
        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";

        global $wpdb;
        $table_news_letter_category = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_news_letter_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';

        // Fetch all parent categories
        $all_category_query = "SELECT * FROM {$table_news_letter_category}";

        if (!empty($search)) {
            $search_term = '%' . $wpdb->esc_like($search) . '%';
            $all_category_query .= $wpdb->prepare(" WHERE category_name LIKE %s", $search_term);
        }

        $all_category_query .= $wpdb->prepare(" ORDER BY id DESC LIMIT %d, %d", $start, $length);
        $all_category = $wpdb->get_results($all_category_query);

        $all_category_data = array();

        foreach ($all_category as $row) {
            $parent_category_data = array(
                'id' => $row->id,
                'category_name' => $row->category_name,
                'type' => 'parent',
                'sub_categories' => array()
            );

            $sub_category_query = $wpdb->prepare("SELECT * FROM {$table_news_letter_sub_category} WHERE parent_category_id = %d", $row->id);
            $sub_categories = $wpdb->get_results($sub_category_query);

            foreach ($sub_categories as $sub_row) {
                $parent_category_data['sub_categories'][] = array(
                    'id' => $sub_row->id,
                    'category_name' => $sub_row->sub_category_name,
                    'type' => 'sub'
                );
            }

            $all_category_data[] = $parent_category_data;
        }

        $total_record = $wpdb->get_var("SELECT COUNT(*) FROM {$table_news_letter_category}");

        $response = [
            'draw' => intval($_POST['draw']),
            'recordsTotal' => $total_record,
            'recordsFiltered' => $total_record,
            'data' => $all_category_data,
        ];

        header('Content-Type: application/json');
        echo json_encode($response);
        wp_die();

    }

    public function BMSI_display_newsletters_tag_callback()
    {
        if (!isset($_POST['news_letter_tag_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_tag_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;
        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;
        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";

        global $wpdb;
        $table_news_letter_tag = $wpdb->prefix . 'bmsi_news_letter_tag';

        $all_tag_query = "SELECT * FROM {$table_news_letter_tag}";

        if (!empty($search)) {
            $search_term = '%' . $wpdb->esc_like($search) . '%';
            $all_tag_query .= $wpdb->prepare(" WHERE tags_name LIKE %s", $search_term);
        }

        $all_tag_query .= $wpdb->prepare(" ORDER BY id DESC LIMIT %d, %d", $start, $length);
        $all_tag = $wpdb->get_results($all_tag_query);

        $all_tag_data = array();

        foreach ($all_tag as $row) {
            $parent_tag_data = array(
                'id' => $row->id,
                'tags_name' => $row->tags_name,
                'type' => 'parent',
            );

            $all_tag_data[] = $parent_tag_data;
        }

        $total_record = $wpdb->get_var("SELECT COUNT(*) FROM {$table_news_letter_tag}");

        $response = [
            'draw' => intval($_POST['draw']),
            'recordsTotal' => $total_record,
            'recordsFiltered' => $total_record,
            'data' => $all_tag_data,
        ];

        header('Content-Type: application/json');
        echo json_encode($response);
        wp_die();

    }

    public function BMSI_delete_template_callback()
    {
        if (!isset($_POST['delete_template_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['delete_template_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        global $wpdb;
        $table = $wpdb->prefix . 'bmsi_design_template';

        $template_id = isset($_POST['template_id']) ? intval($_POST['template_id']) : "";
        
        $delete_sql = $wpdb->get_results($wpdb->prepare("DELETE FROM $table WHERE id = %d",$template_id));

        // print_r($delete_sql);

        if ($delete_sql) {
            $message = "Something Went Wrong.";
            $title = "Alert!";
            $response = [
                'status' => false,
                'title' => esc_html($title, 'bulk-mail'),
                'message' => esc_html($message, 'bulk-mail'),
            ];
        } else {
            $message = "Template Deleted Successfully.";
            $title = "Deleted!";
            $response = [
                'status' => true,
                'title' => esc_html($title, 'bulk-mail'),
                'message' => esc_html($message, 'bulk-mail'),
            ];
        }

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();

    }

    public function BMSI_news_letter_form_shortcode()
    {
        ob_start();
        require_once (BMSI_PRO_DIR_PATH . 'templates/BMSINewsLetterForm.php');
        return ob_get_clean();
    }

    public function BMSI_handle_news_letter_form_callback()
    {
        global $wpdb;

        $email = sanitize_email($_POST['news_email']);
        $category = !empty($_POST['category']) ? sanitize_text_field($_POST['category']) : "";

        $table_name = $wpdb->prefix . 'bmsi_news_letters_email';
        $table_news_letter_category = $wpdb->prefix . 'bmsi_news_letter_category';
        $existing_email = $wpdb->get_var($wpdb->prepare("SELECT email FROM %1s WHERE email = %s", $table_name, $email));
        $existing_category = $wpdb->get_var($wpdb->prepare("SELECT category_name FROM %1s WHERE category_name = %s", $table_news_letter_category, $category));

        if ($existing_email) {
            return;
        } else {
            $wpdb->insert($table_name, array('email' => $email, 'category' => $category));
        }

        if ($existing_category) {
            return;
        } else {
            $wpdb->insert($table_news_letter_category, array('category_name' => $category));
        }
    }

    public function BMSI_display_email_callback()
    {
        // Verify nonce
        if (!isset($_POST['email_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['email_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        // Get request parameters
        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;
        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;
        $search_value = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : '';
        $category = isset($_POST["category"]) ? intval($_POST["category"]) : '';
        $status = isset($_POST["status"]) ? intval($_POST["status"]) : '';

        global $wpdb;
        $table_name = $wpdb->prefix . 'bmsi_news_letters_email';
        $table_category = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';
        $tags_table = $wpdb->prefix . 'bmsi_news_letter_tag';
        // Build WHERE clause based on filters

        $where_clause = 'WHERE 1=1';
        if (!empty($search_value)) {
            $where_clause .= $wpdb->prepare(" AND `email` LIKE %s", '%' . $wpdb->esc_like($search_value) . '%');
        }
        if (!empty($category) && $category != "All") {
            $where_clause .= $wpdb->prepare(" AND `category` = %s", $category);
        }
        if ($status != "2") {
            $where_clause .= $wpdb->prepare(" AND `status` = %d", $status);
        }

        $query = $wpdb->prepare(
            "SELECT * FROM {$table_name} {$where_clause} ORDER BY id DESC LIMIT %d, %d",
            $start,
            $length
        );

        $results = $wpdb->get_results($query);

        $total_records_query = "SELECT COUNT(*) AS total_mail FROM {$table_name} {$where_clause}";
        $total_record = intval($wpdb->get_var($total_records_query));

        $data = array_map(function ($row) use ($wpdb, $table_category, $table_sub_category, $tags_table) {
            $category_name = $wpdb->get_var(
                $wpdb->prepare(
                    "SELECT category_name FROM {$table_category} WHERE id = %d",
                    $row->category
                )
            );

            $subcategory_name = $wpdb->get_var(
                $wpdb->prepare(
                    "SELECT sub_category_name FROM {$table_sub_category} WHERE id = %d",
                    $row->sub_category
                )
            );

            $tag_names = '';
            $row->tag = json_decode($row->tag);

            $i = 1;
            if (!empty($row->tag) && $row->tag != null) {
                foreach($row->tag as $tag_id){
                    if($i > 1) {
                        $tag_names .= ', ';
                    }
                    $tag_names .= $wpdb->get_var($wpdb->prepare("SELECT tags_name FROM {$tags_table} WHERE id = $tag_id"));
                    $i++;
                }
            }

            if (!empty($subcategory_name) && $subcategory_name !== Null) {
                return [
                    'id' => $row->id,
                    'email' => $row->email,
                    'parentcategory' => $category_name,
                    'subcategory' => $subcategory_name,
                    'tag' => !empty($row->tag) && $row->tag != null ? $tag_names : '-',
                    'create_date' => $row->createdate,
                    'status' => ($row->status == "1") ? "Active" : "Inactive",
                ];
            } else {
                return [
                    'id' => $row->id,
                    'email' => $row->email,
                    'parentcategory' => $category_name,
                    'subcategory' => "-",
                    'tag' => !empty($row->tag) && $row->tag != null ? $tag_names : '-',
                    'create_date' => $row->createdate,
                    'status' => ($row->status == "1") ? "Active" : "Inactive",
                ];
            }


        }, $results);

        $response = [
            'draw' => intval($_POST['draw']),
            'recordsTotal' => $total_record,
            'recordsFiltered' => $total_record,
            'data' => $data,
        ];

        // Send JSON response
        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }


    public function BMSI_chart_details_callback()
    {
        if (!isset($_GET['chart_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_GET['chart_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        global $wpdb;
        $table_name = $wpdb->prefix . 'bmsi_total_mail';

        $data_query = $wpdb->prepare("SELECT * FROM %1s", $table_name);
        $data = $wpdb->get_results($data_query);
        $chart_data = array();
        foreach ($data as $row) {
            $chart_data[] = array(
                'createdate' => $row->createdate,
                'user' => $row->user,
                'newsletters' => $row->newsleeter,
                'total' => $row->total
            );
        }

        header('Content-Type: application/json');

        echo wp_json_encode($chart_data);
        wp_die();
    }

    public function BMSI_pro_display_history_callback()
    {
        if (!isset($_POST['pro_history_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['pro_history_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;
        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;
        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";
        $mail_type = isset($_POST["mail_type"]) ? sanitize_text_field($_POST["mail_type"]) : "";

        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_history';

        $where_clause = 'WHERE 1=1';

        if (!empty($search)) {
            $search_term = '%' . $wpdb->esc_like($search) . '%';
            $where_clause .= $wpdb->prepare(" AND from_name LIKE %s", $search_term);
        }

        if (!empty($mail_type) && $mail_type != "All") {
            $mail_type_term = '%' . $wpdb->esc_like($mail_type) . '%';
            $where_clause .= $wpdb->prepare(" AND type LIKE %s", $mail_type_term);
        }

        $query_table1 = $wpdb->prepare(
            "SELECT * FROM {$table_name} {$where_clause} ORDER BY id DESC LIMIT %d, %d",
            $start,
            $length
        );

        $query_table2 = "SELECT COUNT(*) FROM {$table_name} WHERE 1=1";

        if (!empty($search)) {
            $query_table2 .= $wpdb->prepare(" AND from_name LIKE %s", $search_term);
        }

        if (!empty($mail_type) && $mail_type != "All") {
            $query_table2 .= $wpdb->prepare(" AND type LIKE %s", $mail_type_term);
        }

        $results_table = $wpdb->get_results($query_table1);
        $total_filtered_records = $wpdb->get_var($query_table2);



        $chart_data = array();

        foreach ($results_table as $row) {
            $chart_data[] = array(
                'id' => $row->id,
                'from_name' => $row->from_name,
                'subject' => $row->subject,
                'type' => $row->type,
                'createdate' => $row->createdate,
                'open' => $row->open_count,
            );
        }

        $response = [
            'draw' => intval($_POST['draw']),
            'recordsTotal' => $total_filtered_records,
            'recordsFiltered' => $total_filtered_records,
            'data' => $chart_data,
        ];

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();

    }

    public function BMSI_view_record_history_pro_callback()
    {
        if (!isset($_POST['pro_history_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['pro_history_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $id = isset($_POST['id']) ? intval($_POST['id']) : 0;

        global $wpdb;
        $table_name = $wpdb->prefix . 'bmsi_history';
        $query_table1 = $wpdb->prepare("SELECT * FROM %1s WHERE id = %d", $table_name, $id);
        $results_table = $wpdb->get_results($query_table1);

        $body = "";
        if (!empty($results_table)) {
            foreach ($results_table as $result) {
                $body .= $result->body;
            }
        }

        $response = [
            'body' => $body,
        ];

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }

    public function BMSI_news_letter_record_callback()
    {
        if (!isset($_POST['view_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['view_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_POST)) {
            $id = !empty($_POST['id']) ? sanitize_text_field($_POST['id']) : "";

            global $wpdb;

            $table_name = $wpdb->prefix . 'bmsi_news_letters_email';
            $table_category = $wpdb->prefix . 'bmsi_news_letter_category';
            $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';

            $query_table = $wpdb->prepare(
                "SELECT * From %1s where id = %d",
                $table_name,
                $id
            );

            $data = $wpdb->get_results($query_table);

            $category = $wpdb->get_results($wpdb->prepare("SELECT category_name From %1s where id = %d", $table_category, $data[0]->category));

            if (!empty($data[0]->sub_category) && $data[0]->sub_category !== Null) {
                $sub_category = $wpdb->get_results($wpdb->prepare("SELECT sub_category_name From %1s where id = %d", $table_sub_category, $data[0]->sub_category));
                $sub_category_name = $sub_category[0]->sub_category_name;
            } else {
                $sub_category_name = "-";
            }

            $response = array(
                'id' => $id,
                'email' => $data[0]->email,
                'category' => $category[0]->category_name,
                'subcategory' => $sub_category_name,
                'createdate' => $data[0]->createdate,
                'status' => $data[0]->status
            );

            header('Content-Type: application/json');
            echo wp_json_encode($response);
            wp_die();
        }

    }

    public function BMSI_add_new_category_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $categoryp = !empty($_POST['categoryp']) ? sanitize_text_field($_POST['categoryp']) : "";
        $categorys = !empty($_POST['categorys']) ? sanitize_text_field($_POST['categorys']) : "";
        $parentcategory = !empty($_POST['parentcategory']) ? sanitize_text_field($_POST['parentcategory']) : "";
        $category_id = !empty($_POST['category_id']) ? intval($_POST['category_id']) : "";
        $edit_permission = !empty($_POST['edit']) ? sanitize_text_field($_POST['edit']) : "false";

        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';
        $table_bmsi_news_letters_email = $wpdb->prefix . 'bmsi_news_letters_email';

        $existing_parent_category = "";
        $existing_sub_category = "";

        if ($edit_permission == "true") {

            if (!empty($categorys)) {
                $parent_id_data = $wpdb->get_results($wpdb->prepare("SELECT parent_category_id FROM %1s WHERE id = %d", $table_sub_category, $category_id));
                if (!empty($parent_id_data)) {
                    foreach ($parent_id_data as $key => $category_data) {
                        $parent_id = $category_data->parent_category_id;
                    }
                }
            }

            if (!empty($categoryp)) {
                $existing_parent_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE id = %d", $table_name, $category_id));
            } else {
                $exist_sub_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE id = %d and parent_category_id = %d", $table_sub_category, $category_id, $parent_id));
            }

            if (!empty($existing_parent_category_data)) {
                foreach ($existing_parent_category_data as $key => $category_data) {
                    $existing_parent_category = $category_data->category_name;
                    $existing_parent_category_id = $category_data->id;
                }
            }

            if (!empty($exist_sub_category_data)) {
                foreach ($exist_sub_category_data as $key => $category_data) {
                    $exist_sub_category = $category_data->sub_category_name;
                }
            }

            if (!empty($existing_parent_category)) {

                if ($existing_parent_category == $categoryp) {
                    $message = "Parent Category Alerdy Exists.";
                    $title = "Alert!";
                    $response = [
                        'status' => true,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),
                    ];
                } else {


                    $update_sql = $wpdb->prepare("
                UPDATE %1s SET `category_name` = '%s' WHERE `id` = '%d'", $table_name, $categoryp, $category_id);

                    $data = $wpdb->query($update_sql);

                    if ($data > 0) {
                        $message = "Parnet Category Updated Successfully.";
                        $title = "Congratulations!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    } else {
                        $message = "Something Went Wrong.";
                        $title = "Alert!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    }
                }

            } else {
                if ($exist_sub_category == $categorys) {
                    $message = "Subcategory Alerdy Exists.";
                    $title = "Alert!";
                    $response = [
                        'status' => true,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),
                    ];
                } else {


                    $update_sql = $wpdb->prepare("
                UPDATE %1s SET `sub_category_name` = '%s' WHERE `id` = '%d'", $table_sub_category, $categorys, $category_id);

                    $data = $wpdb->query($update_sql);

                    if ($data > 0) {
                        $message = "Subcategory Updated Successfully.";
                        $title = "Congratulations!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    } else {
                        $message = "Something Went Wrong.";
                        $title = "Alert!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    }
                }
            }
        } else {
            if (!empty($categoryp)) {
                $existing_parent_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE category_name = %s", $table_name, $categoryp));
            } else {
                $exist_parent_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE category_name = %s", $table_name, $categorys));
            }

            if (!empty($existing_parent_category_data)) {
                foreach ($existing_parent_category_data as $key => $category_data) {
                    $existing_parent_category = $category_data->category_name;
                    $existing_parent_category_id = $category_data->id;
                }
            }

            if (!empty($exist_parent_category_data)) {
                foreach ($exist_parent_category_data as $key => $category_data) {
                    $exist_parent_category = $category_data->category_name;
                }
            }

            if (empty($exist_parent_category)) {
                if (!empty($existing_parent_category)) {
                    $existing_sub_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE parent_category_id = %d AND sub_category_name = %s", $table_sub_category, $existing_parent_category_id, $categorys));

                    if (!empty($existing_sub_category_data)) {
                        foreach ($existing_sub_category_data as $key => $category_data) {
                            $existing_sub_category = $category_data->sub_category_name;
                        }
                    }

                    if (!empty($existing_sub_category)) {
                        $message = "SubCategory Alerdy Exists.";
                        $title = "Alert!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    } else {
                        $insert_sql = $wpdb->prepare("
                        INSERT INTO %1s (`sub_category_name`,`parent_category_id`) VALUES (%s,%d) ", $table_sub_category, $categorys, $existing_parent_category_id);

                        $data = $wpdb->query($insert_sql);

                        if ($data > 0) {
                            $message = "Sub Category added Successfully.";
                            $title = "Congratulations!";
                            $response = [
                                'status' => true,
                                'title' => esc_html($title, 'bulk-mail'),
                                'message' => esc_html($message, 'bulk-mail'),
                            ];
                        } else {
                            $message = "Something Went Wrong.";
                            $title = "Alert!";
                            $response = [
                                'status' => true,
                                'title' => esc_html($title, 'bulk-mail'),
                                'message' => esc_html($message, 'bulk-mail'),
                            ];
                        }
                    }

                } else {
                    $insert_sql = $wpdb->prepare("
                        INSERT INTO %1s (`category_name`) VALUES (%s) ", $table_name, $categorys);

                    $data = $wpdb->query($insert_sql);

                    if ($data > 0) {
                        $message = "Parent Category added Successfully.";
                        $title = "Congratulations!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    } else {
                        $message = "Something Went Wrong.";
                        $title = "Alert!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    }

                }
            } else {
                $message = "Parent Category Alerdy Exists.";
                $title = "Congratulations!";
                $response = [
                    'status' => true,
                    'title' => esc_html($title, 'bulk-mail'),
                    'message' => esc_html($message, 'bulk-mail'),
                ];
            }

        }

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }

    public function BMSI_add_new_tag_callback()
    {
        if (!isset($_POST['news_letter_tag_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_tag_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $tagp = !empty($_POST['tagp']) ? sanitize_text_field($_POST['tagp']) : "";
        $tags = !empty($_POST['tags']) ? sanitize_text_field($_POST['tags']) : "";
        $tag_id = !empty($_POST['tag_id']) ? intval($_POST['tag_id']) : "";
        $edit_permission = !empty($_POST['edit']) ? sanitize_text_field($_POST['edit']) : "false";

        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_news_letter_tag';

        $existing_tag = "";

        if ($edit_permission == "true") {

            if (!empty($tagp)) {
                $existing_tag_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE id = %d", $table_name, $tag_id));
            }

            if (!empty($existing_tag_data)) {
                foreach ($existing_tag_data as $key => $tag_data) {
                    $existing_tag = $tag_data->tags_name;
                    $existing_tag_id = $tag_data->id;
                }
            }

            if (!empty($existing_tag)) {

                if ($existing_tag == $tagp) {
                    $message = "tag Alerdy Exists.";
                    $title = "Alert!";
                    $response = [
                        'status' => true,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),
                    ];
                } else {


                    $update_sql = $wpdb->prepare("
                UPDATE %1s SET `tags_name` = '%s' WHERE `id` = '%d'", $table_name, $tagp, $tag_id);

                    $data = $wpdb->query($update_sql);

                    if ($data > 0) {
                        $message = "Tag Updated Successfully.";
                        $title = "Congratulations!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    } else {
                        $message = "Something Went Wrong.";
                        $title = "Alert!";
                        $response = [
                            'status' => true,
                            'title' => esc_html($title, 'bulk-mail'),
                            'message' => esc_html($message, 'bulk-mail'),
                        ];
                    }
                }

            }
        } else {
            if (!empty($tagp)) {
                $existing_tag_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE tags_name = %s", $table_name, $tagp));
            } else {
                $exist_tag_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE tags_name = %s", $table_name, $tags));
            }

            if (!empty($existing_tag_data)) {
                foreach ($existing_tag_data as $key => $tag_data) {
                    $existing_tag = $tag_data->tags_name;
                    $existing_tag_id = $tag_data->id;
                }
            }

            if (!empty($exist_tag_data)) {
                foreach ($exist_tag_data as $key => $tag_data) {
                    $exist_tag = $tag_data->tags_name;
                }
            }

            if (empty($exist_tag)) {
                $insert_sql = $wpdb->prepare("
                    INSERT INTO %1s (`tags_name`) VALUES (%s) ", $table_name, $tags);

                $data = $wpdb->query($insert_sql);

                if ($data > 0) {
                    $message = "Tag added Successfully.";
                    $title = "Congratulations!";
                    $response = [
                        'status' => true,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),
                    ];
                } else {
                    $message = "Something Went Wrong.";
                    $title = "Alert!";
                    $response = [
                        'status' => true,
                        'title' => esc_html($title, 'bulk-mail'),
                        'message' => esc_html($message, 'bulk-mail'),
                    ];
                }
            } else {
                $message = "Tag Alerdy Exists.";
                $title = "Congratulations!";
                $response = [
                    'status' => true,
                    'title' => esc_html($title, 'bulk-mail'),
                    'message' => esc_html($message, 'bulk-mail'),
                ];
            }

        }

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }

    
    public function BMSI_add_news_letter_user_category_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }
        $fname = !empty($_POST['fname']) ? $_POST['fname'] : "";
        $lname = !empty($_POST['lname']) ? $_POST['lname'] : "";
        $job_title = !empty($_POST['job_title']) ? $_POST['job_title'] : "";
        $company = !empty($_POST['company']) ? $_POST['company'] : "";
        $birthdate = !empty($_POST['birthdate']) ? $_POST['birthdate'] : "";  
        $anniversary = !empty($_POST['anniversary']) ? $_POST['anniversary'] : "";
        $category = !empty($_POST['category']) ? intval($_POST['category']) : "";
        $subcategory = !empty($_POST['subcategory']) ? intval($_POST['subcategory']) : "";
        $email = !empty($_POST['email']) ? sanitize_text_field($_POST['email']) : "";
        $tags = !empty($_POST['tags']) ? json_encode($_POST['tags']) : "";
        $status = !empty($_POST['status']) ? intval($_POST['status']) : "";

        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_news_letters_email';
        $table_category = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';

        $query_existing_email = $wpdb->prepare("SELECT * FROM $table_name WHERE email = %s", $email);
        $existing_email = $wpdb->get_row($query_existing_email);

        if ($existing_email) {
            $message = "Contact Email already exists.";
            $title = "Alert!";
            $response = [
                'status' => true,
                'message' => esc_html($message, 'bulk-mail'),
                'title' => esc_html($title, 'bulk-mail'),
            ];
        } else {
            $data = 0;

            if (!empty($category)) {
                $parent_category_id = $category;
                $insert_sql = $wpdb->prepare(
                    "INSERT INTO $table_name (email, fname, lname, job_title, company, birthdate, anniversary, category, sub_category, tag, status) 
                    VALUES ('$email', '$fname', '$lname', '$job_title', '$company', '$birthdate', '$anniversary', '$parent_category_id', '-','$tags','$status')"
                );

                $data = $wpdb->query($insert_sql);
            }

            if (!empty($subcategory)) {
                $sub_category_id = $subcategory;

                $parent_category_data = $wpdb->get_results($wpdb->prepare("SELECT parent_category_id FROM $table_sub_category WHERE id = %d", $sub_category_id));
                if (!empty($parent_category_data)) {
                    $parent_category_id = $parent_category_data[0]->parent_category_id;

                    $insert_sql = $wpdb->prepare(
                    "INSERT INTO $table_name (email, fname, lname, job_title, company, birthdate, anniversary, category, sub_category, tag, status) 
                    VALUES ('$email', '$fname', '$lname', '$job_title', '$company', '$birthdate', '$anniversary', '$parent_category_id', '$sub_category_id','$tags','$status')"
                    );

                    $data = $wpdb->query($insert_sql);
                }
            }

            if ($data > 0) {
                $message = "Contact Email Created Successfully";
                $title = "Congratulations!";
                $response = [
                    'status' => true,
                    'title' => esc_html($title, 'bulk-mail'),
                    'message' => esc_html($message, 'bulk-mail'),
                ];
            } else {
                $message = "Something Went Wrong.";
                $title = "Alert!";
                $response = [
                    'status' => true,
                    'title' => esc_html($title, 'bulk-mail'),
                    'message' => esc_html($message, 'bulk-mail'),
                ];
            }
        }

        header('Content-Type: application/json');
        echo json_encode($response);
        wp_die();
    }

    public function BMSI_edit_news_letter_user_category_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $fname = !empty($_POST['fname']) ? $_POST['fname'] : "";
        $lname = !empty($_POST['lname']) ? $_POST['lname'] : "";
        $job_title = !empty($_POST['job_title']) ? $_POST['job_title'] : "";
        $company = !empty($_POST['company']) ? $_POST['company'] : "";
        $birthdate = !empty($_POST['birthdate']) ? $_POST['birthdate'] : "";  
        $anniversary = !empty($_POST['anniversary']) ? $_POST['anniversary'] : "";
        $tags = !empty($_POST['tags']) ? json_encode($_POST['tags']) : "";
        $parentcategory = !empty($_POST['parentcategory']) ? intval($_POST['parentcategory']) : "";
        $subcategory = !empty($_POST['subcategory']) ? intval($_POST['subcategory']) : "";
        $email = !empty($_POST['email']) ? sanitize_text_field($_POST['email']) : "";
        $id = !empty($_POST['id']) ? intval($_POST['id']) : "";
        $status = !empty($_POST['status']) ? intval($_POST['status']) : "";

        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_news_letters_email';
        $table_category = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';


        if ($parentcategory > 0) {
            $update_sql = $wpdb->prepare("
            UPDATE {$table_name} 
            SET `email` = '$email', `category` = '$parentcategory', `sub_category` = 'Null', `status` = '$status', `fname` = '$fname', `lname` = '$lname', `job_title` = '$job_title', `company` = '$company', `birthdate` = '$birthdate',  `anniversary` = '$anniversary', `tag` = '$tags' WHERE `id` = '$id'");
        } else {
            $parent_category_id = $wpdb->get_results($wpdb->prepare("SELECT parent_category_id FROM {$table_sub_category} WHERE id = %d", $subcategory));
            $parent_category_id = $parent_category_id[0]->parent_category_id;
            $update_sql = $wpdb->prepare("
            UPDATE {$table_name} 
            SET `email` = '$email', `category` = '$parent_category_id', `sub_category` = '$subcategory', `status` = '$status', `fname` = '$fname', `lname` = '$lname', `job_title` = '$job_title', `company` = '$company', `birthdate` = '$birthdate',  `anniversary` = '$anniversary', `tag` = '$tags' WHERE `id` = '$id'");
        }

        $data = $wpdb->query($update_sql);

        $message = "Contact Email Edited Successfully.";
        $title = "Congratulations!";
        $response = [
            'status' => true,
            'title' => esc_html($title, 'bulk-mail'),
            'message' => esc_html($message, 'bulk-mail'),
        ];

        header('Content-Type: application/json');
        echo json_encode($response);
        wp_die();
    }


    public function BMSI_delete_news_letter_email_callback()
    {
        if (!isset($_POST['news_letter_email_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_email_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        global $wpdb;

        $table = $wpdb->prefix . 'bmsi_news_letters_email';

        $id = !empty($_POST["id"]) ? $_POST["id"] : "";

        $delete_sql = $wpdb->get_results($wpdb->prepare("DELETE FROM $table WHERE id = $id"));

        if ($delete_sql) {
            $message = "Something went wrong";
            $title = "Alert!";
            $response = [
                'status' => true,
                'title' => esc_html($title, 'bulk-mail'),
                'message' => esc_html($message, 'bulk-mail'),
            ];
        } else {
            $message = "Email Deleted Successfully.";
            $title = "Congratulations!";
            $response = [
                'status' => true,
                'title' => esc_html($title, 'bulk-mail'),
                'message' => esc_html($message, 'bulk-mail'),
            ];
        }

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();

    }
    public function BMSI_get_sub_categories_callback()
    {
        global $wpdb;

        $parent_id = intval($_POST['parent_id']);
        $table_name = $wpdb->prefix . 'bmsi_news_letter_sub_category';

        $data = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name WHERE parent_category_id = %d", $parent_id));

        if (!empty($data)) {
            wp_send_json_success(array('data' => $data));
        } else {
            wp_send_json_error();
        }

        wp_die();
    }

    public function BMSI_fetch_categories_and_subcategories_callback()
    {
        if (!isset($_POST['news_letter_category_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_category_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $id = !empty($_POST['id']) ? intval($_POST['id']) : "";

        global $wpdb;
        $table_category = $wpdb->prefix . 'bmsi_news_letter_category';
        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';

        $parent_categories = $wpdb->get_results("SELECT * FROM $table_category");

        $subcategories = $wpdb->get_results("SELECT * FROM $table_sub_category");

        $grouped_subcategories = [];
        if (!empty($subcategories)) {
            foreach ($subcategories as $sub) {
                $grouped_subcategories[$sub->parent_category_id][] = $sub;
            }
        }

        if (!empty($parent_categories)) {
            foreach ($parent_categories as $category) {
                $category->subcategories = isset($grouped_subcategories[$category->id]) ? $grouped_subcategories[$category->id] : [];
            }
        }

        wp_send_json_success(['data' => $parent_categories]);
        wp_die();
    }

    public function BMSI_fetch_tags_callback()
    {
        if (!isset($_POST['news_letter_tag_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['news_letter_tag_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        $id = !empty($_POST['id']) ? intval($_POST['id']) : "";

        global $wpdb;
        $table_tags = $wpdb->prefix . 'bmsi_news_letter_tags';

        $parent_tags = $wpdb->get_results("SELECT * FROM $table_tags");

        wp_send_json_success(['data' => $parent_tags]);
        wp_die();
    }

    public function BMSI_Import_newsletter_email_callback() {
        if (!isset($_POST['import_file_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['import_file_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }
    
        if (!isset($_FILES['file']) || empty($_FILES['file']['name'])) {
            wp_send_json_error(['message' => 'No file uploaded.']);
            return;
        }
    
        $file = $_FILES['file'];
        $file_extension = pathinfo($file['name'], PATHINFO_EXTENSION);
    
        if (!in_array($file_extension, ['csv', 'xlsx'])) {
            wp_send_json_error(['message' => 'Invalid file type.']);
            return;
        }
    
        $file_data = file_get_contents($file['tmp_name']);
        $data = [];
    
        if ($file_extension === 'csv') {
            $rows = array_map('str_getcsv', explode("\n", $file_data));
    
            if (substr($rows[0][0], 0, 3) === "\xEF\xBB\xBF") {
                $rows[0][0] = substr($rows[0][0], 3);
            }
    
            $header = array_map(function ($value) {
                return trim($value, '"');
            }, array_shift($rows));
            $header = array_map('trim', $header);
    
            foreach ($rows as $row) {
                if (empty($row) || count($header) !== count($row)) {
                    continue;
                }
                $row = array_map(function ($value) {
                    return trim($value, '"');
                }, $row);
                $data[] = array_combine($header, $row);
            }
        } elseif ($file_extension === 'xlsx') {
            $spreadsheet = IOFactory::load($file['tmp_name']);
            $sheetData = $spreadsheet->getActiveSheet()->toArray();
    
            $header = array_map('trim', $sheetData[0]);
            $data = [];
    
            foreach (array_slice($sheetData, 1) as $row) {
                if (count($header) !== count($row)) {
                    continue;
                }
                $data[] = array_combine($header, array_map('trim', $row));
            }
        }
    
        $error = "";
        $required_fields = ['email', 'parent_category', 'status'];
        foreach ($data as $row) {
            foreach ($required_fields as $field) {
                if (!isset($row[$field])) {
                    $error = $field;
                    break 2;
                }
            }
        }
    
        if (empty($error)) {
            ini_set('display_errors', 1);
            global $wpdb;
            $count_data = count($data);
    
            foreach ($data as $row) {
                $email = sanitize_email($row['email']) ?? "";
                $parent_category = isset($row['parent_category']) && !empty($row['parent_category']) ? sanitize_text_field($row['parent_category']) : 'uncategory';
                $sub_category = isset($row['sub_category']) ? sanitize_text_field($row['sub_category']) : null;
                $status = (strtolower($row['status']) === 'active') ? 1 : 0;
    
                if (!is_email($email)) {
                    error_log("Invalid email: " . $email);
                    continue;
                }
    
                $category_table = $wpdb->prefix . 'bmsi_news_letter_category';
                $sub_category_table = $wpdb->prefix . 'bmsi_news_letter_sub_category';
                $newsletter_table = $wpdb->prefix . 'bmsi_news_letters_email';
                $tag_table = $wpdb->prefix . 'bmsi_news_letter_tag';
    
                $parent_category_id = $wpdb->get_var(
                    $wpdb->prepare(
                        "SELECT id FROM $category_table WHERE category_name = %s",
                        $parent_category
                    )
                );
    
                if ($parent_category_id === null) {
                    $wpdb->insert(
                        $category_table,
                        ['category_name' => $parent_category],
                        ['%s']
                    );
                    $parent_category_id = $wpdb->insert_id;
                }
    
                $sub_category_id = null;
                if (!empty($sub_category)) {
                    $sub_category_id = $wpdb->get_var(
                        $wpdb->prepare(
                            "SELECT id FROM $sub_category_table WHERE sub_category_name = %s AND parent_category_id = %d",
                            $sub_category,
                            $parent_category_id
                        )
                    );
    
                    if ($sub_category_id === null) {
                        $wpdb->insert(
                            $sub_category_table,
                            ['sub_category_name' => $sub_category, 'parent_category_id' => $parent_category_id],
                            ['%s', '%d']
                        );
                        $sub_category_id = $wpdb->insert_id;
                    }
                }
    
                $tags = isset($row['tag']) ? explode(',', $row['tag']) : [];
                $tag_ids = [];
                foreach ($tags as $tag) {
                    $tag = trim($tag);
                    if (!empty($tag)) {
                        $tag_id = $wpdb->get_var(
                            $wpdb->prepare(
                                "SELECT id FROM $tag_table WHERE tags_name = %s",
                                $tag
                            )
                        );
    
                        if ($tag_id === null) {
                            $wpdb->insert(
                                $tag_table,
                                ['tags_name' => $tag],
                                ['%s']
                            );
                            $tag_id = $wpdb->insert_id;
                        }

                        if(!empty($tag_id)) {
                            $tag_ids[] = (string)$tag_id;
                        } else {
                            $wpdb->insert($tag_table,['tags_name' => $tag],['%s']);
                            $tag_id = $wpdb->insert_id;
                            $tag_ids[] = (string)$tag_id;
                        }
                    }
                }
    
                // Check if email already exists
                $email_data = $wpdb->get_var(
                    $wpdb->prepare(
                        "SELECT id FROM $newsletter_table WHERE email = %s",
                        $email
                    )
                );
    
                if ($email_data) {
                    $count_data--;
                } else {
                    // Insert email data
                    $insert_data = [
                        'email' => $email,
                        'category' => $parent_category_id,
                        'sub_category' => $sub_category_id,
                        'status' => $status,
                        'fname' => sanitize_text_field($row['fname'] ?? ''),
                        'lname' => sanitize_text_field($row['lname'] ?? ''),
                        'job_title' => sanitize_text_field($row['job_title'] ?? ''),
                        'company' => sanitize_text_field($row['company'] ?? ''),
                        'birthdate' => sanitize_text_field($row['birthdate'] ?? ''),
                        'anniversary' => sanitize_text_field($row['anniversary'] ?? ''),
                        'tag' => json_encode($tag_ids) // Insert tag IDs as a JSON-encoded array of strings
                    ];
    
                    error_log('Insert data: ' . print_r($insert_data, true)); // Add debug log for insert data
    
                    $wpdb->insert(
                        $newsletter_table,
                        $insert_data,
                        [
                            '%s',
                            '%d',
                            '%d',
                            '%d',
                            '%s',
                            '%s',
                            '%s',
                            '%s',
                            '%s',
                            '%s',
                            '%s' 
                        ]
                    );

                    // print_r($wpdb);
                    // die;
    
                    if ($wpdb->last_error) {
                        error_log("Insert error: " . $wpdb->last_error);
                    }
                }
            }
    
            if ($count_data > 0) {
                $response = [
                    'status' => true,
                    "message" => "File imported successfully.",
                ];
            } else {
                $response = [
                    'status' => true,
                    "message" => "File data is already imported.",
                ];
            }
        } else {
            $response = [
                'status' => false,
                "message" => $error . " field is required.",
            ];
        }
    
        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }

    public function BMSI_Import_newsletter_email_columnlist_callback()
    {
        if (!isset($_POST['import_file_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['import_file_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        if (!isset($_FILES['file']) || empty($_FILES['file']['name'])) {
            wp_send_json_error(['message' => 'No file uploaded.']);
            return;
        }

        $file = $_FILES['file'];
        $file_extension = pathinfo($file['name'], PATHINFO_EXTENSION);

        if (!in_array($file_extension, ['csv', 'xlsx'])) {
            wp_send_json_error(['message' => 'Invalid file type.']);
            return;
        }

        $file_data = file_get_contents($file['tmp_name']);
        $data = [];
        if ($file_extension === 'csv') {
            $rows = array_map('str_getcsv', explode("\n", $file_data));

            if (substr($rows[0][0], 0, 3) === "\xEF\xBB\xBF") {
                $rows[0][0] = substr($rows[0][0], 3);
            }

            $header = array_map(function ($value) {
                return trim($value, '"');
            }, array_shift($rows));
            $header = array_map('trim', $header);

            foreach ($rows as $row) {
                if (empty($row) || count($header) !== count($row)) {
                    continue;
                }
                $row = array_map(function ($value) {
                    return trim($value, '"');
                }, $row);
                $data[] = array_combine($header, $row);
            }
            $json_data = json_encode($data);
            $data = json_decode($json_data, true);
        } elseif ($file_extension === 'xlsx') {
            $spreadsheet = IOFactory::load($file['tmp_name']);
            $sheetData = $spreadsheet->getActiveSheet()->toArray();
        }



        if (empty($error)) {
            $response = [
                'status' => true,
                'data' => $sheetData[0],
                "message" => "File imported successfully.",
            ];
        } else {
            $response = [
                'status' => false,
                "message" => "Somthing went wrong",
            ];
        }

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }

    public function BMSI_Import_newsletter_category_callback()
    {
        if (!isset($_POST['import_file_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['import_file_nonce'])), 'ajax-nonce')) {
            die('Nonce verification failed');
        }

        if (!isset($_FILES['file']) || empty($_FILES['file']['name'])) {
            wp_send_json_error(['message' => 'No file uploaded.']);
            return;
        }

        $file = $_FILES['file'];
        $file_extension = pathinfo($file['name'], PATHINFO_EXTENSION);

        if (!in_array($file_extension, ['csv', 'xlsx', 'json'])) {
            wp_send_json_error(['message' => 'Invalid file type.']);
            return;
        }

        $file_data = file_get_contents($file['tmp_name']);
        $data = [];

        if ($file_extension === 'json') {
            $data = json_decode($file_data, true);
        } elseif ($file_extension === 'csv') {
            $rows = array_map('str_getcsv', explode("\n", $file_data));

            if (substr($rows[0][0], 0, 3) === "\xEF\xBB\xBF") {
                $rows[0][0] = substr($rows[0][0], 3);
            }

            $header = array_map(function ($value) {
                return trim($value, '"');
            }, array_shift($rows));
            $header = array_map('trim', $header);

            foreach ($rows as $row) {
                if (empty($row) || count($header) !== count($row)) {
                    continue;
                }
                $row = array_map(function ($value) {
                    return trim($value, '"');
                }, $row);
                $data[] = array_combine($header, $row);
            }
            $json_data = json_encode($data);
            $data = json_decode($json_data, true);
        } elseif ($file_extension === 'xlsx') {
            $spreadsheet = IOFactory::load($file['tmp_name']);
            $sheetData = $spreadsheet->getActiveSheet()->toArray();

            $header = array_map('trim', $sheetData[0]);
            $data = [];

            foreach (array_slice($sheetData, 1) as $row) {
                if (count($header) !== count($row)) {
                    continue;
                }
                $data[] = array_combine($header, array_map('trim', $row));
            }
        }

        $error = "";
        $required_fields = ['parent_category'];
        foreach ($data as $row) {
            foreach ($required_fields as $field) {
                if (!isset($row[$field])) {
                    $error = $field;
                    break 2;
                }
            }
        }

        $count_data = (int) count($data);

        if (empty($error)) {
            global $wpdb;
            $category_table = $wpdb->prefix . 'bmsi_news_letter_category';
            $sub_category_table = $wpdb->prefix . 'bmsi_news_letter_sub_category';

            foreach ($data as $row) {
                $parent_category = sanitize_text_field($row['parent_category']);
                $sub_category = isset($row['sub_category']) ? sanitize_text_field($row['sub_category']) : null;

                $parent_category_id = $wpdb->get_var(
                    $wpdb->prepare(
                        "SELECT id FROM $category_table WHERE category_name = %s",
                        $parent_category
                    )
                );

                if ($parent_category_id === null) {
                    $wpdb->insert(
                        $category_table,
                        ['category_name' => $parent_category],
                        ['%s']
                    );
                    $parent_category_id = $wpdb->insert_id;
                } else {
                    $count_data--;
                }

                if (!empty($sub_category)) {
                    $sub_category_id = $wpdb->get_var(
                        $wpdb->prepare(
                            "SELECT id FROM $sub_category_table WHERE sub_category_name = %s AND parent_category_id = %d",
                            $sub_category,
                            $parent_category_id
                        )
                    );

                    if ($sub_category_id === null) {
                        $wpdb->insert(
                            $sub_category_table,
                            ['sub_category_name' => $sub_category, 'parent_category_id' => $parent_category_id],
                            ['%s', '%d']
                        );
                        $sub_category_id = $wpdb->insert_id;
                    }
                }
            }

            if ($count_data > 0) {

                $response = [
                    'status' => true,
                    'message' => 'File imported successfully.',
                ];

            } else {

                $response = [
                    'status' => true,
                    'message' => 'file data is alredy imported.',
                ];

            }
        } else {
            $response = [
                'status' => false,
                'message' => $error . " field is required.",
            ];
        }

        header('Content-Type: application/json');
        echo wp_json_encode($response);
        wp_die();
    }

}


?>