<?php
if (!defined('ABSPATH'))
    exit;

if (isset($_GET) && $_GET["edit"] == "true") {
    $template = !empty($_GET['template_name']) ? sanitize_text_field($_GET['template_name']) : "";

    $posts = get_posts(
        array(
            'post_type' => 'BMSI_Pro_Templates',
            'post_status' => 'publish',
            'name' => $template,
            'posts_per_page' => -1,
        )
    );

    $template_id = !empty($posts[0]->ID) ? sanitize_text_field($posts[0]->ID) : "";
    $post_meta = !empty(get_post_meta($template_id)) ? get_post_meta($template_id) : "";
    $template_name = !empty($posts[0]->post_title) ? sanitize_text_field($posts[0]->post_title) : "";
    $subject = !empty($post_meta['template_subject'][0]) ? sanitize_text_field($post_meta['template_subject'][0]) : "";
    $email_from_name = !empty($post_meta['mail_from_name'][0]) ? sanitize_text_field($post_meta['mail_from_name'][0]) : "";
    $email_from_id = !empty($post_meta['mail_from_email'][0]) ? sanitize_text_field($post_meta['mail_from_email'][0]) : "";
    $template_body = !empty($posts[0]->post_content) ? wp_kses_post($posts[0]->post_content) : "";

}

$args = array(
    'role' => 'administrator',
);

$users = get_users($args);

if (get_option('BMIS_Pro_activated')) {
    ?>

    <?php require_once (BMSI_DIR_PATH . 'templates/BMSIHeader.php'); ?>
    <div class="col-lg-10">
        <div class="main mail-data">

            <form action="#" method="POST" class="create_template">
                <div class="send_mail_data">
                    <input type="hidden" name="template_nonce" id="template_nonce" value="" />
                    <div class="pt-2"></div>
                    <div class="create_template_form_contant">
                        <div
                            class="d-lg-flex d-md-flex d-sm-flex d-block justify-content-between flex-row align-items-center">
                            <div class="title">
                                <h1 class="fw-bold" style="font-size: 40px;">Create New Template</h1>
                            </div>
                            <div
                                class="d-flex justify-content-lg-between justify-content-md-between justify-content-sm-between justify-content-start flex-row">
                                <button class="add-button border-0 btn-back"><a class="btn-back"
                                        href="<?php printf(esc_html('%sadmin.php?page=templates', 'bulk-mail-sender-pro'), esc_html($admin_url)); ?>">Back</a></button>
                                <button class="add-button border-0 btn-cnt"><span class="btn-txt">Save</span><i
                                        class="fa-solid fa-spinner spinn"></i></button>
                            </div>
                        </div>
                        <div class="subjectAndemailfrom">
                            <div class="emailfrom d-flex">
                                <label for="template_name" class="mt-xl-0 mt-lg-0 mt-md-0 mt-sm-3 mt-3">Template
                                    Name</label>
                                <input type="text" name="template_name" id="template_name"
                                    value="<?php echo !empty($template_name) ? esc_html__($template_name, 'bulk-mail') : ""; ?>"
                                    class="template_name input-groups" placeholder="Enter Template Name">
                            </div>
                        </div>
                        <div class="subjectAndemailfrom">
                            <div class="d-flex">
                                <label for="mail_sub" class="mt-xl-0 mt-lg-0 mt-md-0 mt-sm-3 mt-3">Subject</label>
                                <input type="text" name="subject" id="mail_sub"
                                    value="<?php echo !empty($subject) ? esc_html__($subject, 'bulk-mail') : ""; ?>"
                                    class="mail_sub input-groups" placeholder="Enter User First Name">
                            </div>
                            <div class="d-flex">
                                <label for="mail_from" class="mt-xl-0 mt-lg-0 mt-md-0 mt-sm-3 mt-3">Email From Name</label>
                                <input type="text" name="mail_from" id="mail_from"
                                    value="<?php echo !empty($email_from_name) ? esc_html__($email_from_name, 'bulk-mail') : ""; ?>"
                                    class="mail_from input-groups" placeholder="Enter User Last Name">
                            </div>
                        </div>
                        <div class="subjectAndemailfrom firstAndLastName">
                            <div class="emailfrom d-flex">
                                <label for="admin_mail" class="mt-xl-0 mt-lg-0 mt-md-0 mt-sm-3 mt-3">Email From</label>
                                <select name="admin_mail" id="admin_mail" class="input-groups">

                                    <?php if (!empty($email_from_id)) { ?>
                                        <option value="<?php echo esc_attr($email_from_id); ?>">
                                            <?php echo esc_attr($email_from_id); ?>
                                        </option>
                                    <?php } ?>

                                    <?php
                                    if (isset($email_from_id)) {
                                        foreach ($users as $user) {
                                            if ($user->user_email !== $email_from_id) { ?>
                                                <option value="<?php echo esc_attr($user->user_email); ?>">
                                                    <?php echo esc_attr($user->user_email); ?>
                                                </option>
                                                <?php
                                            }
                                        }
                                    } else {
                                        foreach ($users as $user) { ?>

                                            <option value="<?php echo esc_attr($user->user_email); ?>">
                                                <?php echo esc_attr($user->user_email); ?>
                                            </option>
                                            <?php
                                        }
                                    }
                                    ?>

                                </select>
                            </div>
                        </div>
                        <div>
                            <label for="mail_contant" class="mt-xl-0 mt-lg-0 mt-md-0 mt-sm-3 mt-3">Email Body</label><br>
                            <?php
                            $content = !empty($template_body) ? $template_body : "add some text";
                            $editor_id = 'bmsi_mail_box';
                            $editor_name = 'bmsi_mail_box_content';
                            $settings = array(
                                'textarea_rows' => 8,
                                'media_buttons' => true,
                                'quicktags' => array('buttons' => 'strong,em,link,block,del,ins,img,ul,ol,li,code'),
                                'tinymce' => true,
                                'editor_name' => $editor_name,
                            );
                            $headers = array('Content-Type: text/html; charset=UTF-8');
                            wp_editor($content, $editor_id, $settings, $headers);
                            ?>
                            <span class="bmsi_mail_box_error error"></span>
                        </div>
                        <div class="text-end">
                            <input type="hidden" name="edit_permission" id="edit_permission"
                                value="<?php echo esc_html__($_GET["edit"], 'bulk-mail'); ?>">
                            <input type="hidden" name="template_id" id="template_id"
                                value="<?php echo esc_html__($template_id, 'bulk-mail'); ?>">
                            <button type="submit" name="submit" class="add-button fs-16 border-0 btn-cnt" id="submit"><span
                                    class="btn-txt">Save</span><i class="fa-solid fa-spinner spinn"></i>
                            </button>
                        </div>
                    </div>
                </div>
        </div>
        </form>
    </div>
<?php } else { ?>

    <div class="template-bg-image d-flex justify-content-center align-items-center">
        <div class="dashboard-wrapper">
            <div class="bg-color p-3 rounded-4 mx-5">
                <svg xmlns="http://www.w3.org/2000/svg" width="55" height="55" viewBox="0 0 66 75" fill="none">
                    <path
                        d="M58.8933 37.3734H22.9333V22.4884C22.9333 16.7711 27.5298 12.0212 33.2718 11.9635C39.0718 11.9057 43.8133 16.5979 43.8133 22.3584V24.6684C43.8133 26.5886 45.3648 28.1334 47.2933 28.1334H51.9333C53.8618 28.1334 55.4133 26.5886 55.4133 24.6684V22.3584C55.4133 10.231 45.4808 0.37016 33.3008 0.413472C21.1208 0.456785 11.3333 10.4475 11.3333 22.575V37.3734H7.85331C4.01081 37.3734 0.893311 40.4775 0.893311 44.3034V67.4033C0.893311 71.2293 4.01081 74.3333 7.85331 74.3333H58.8933C62.7358 74.3333 65.8533 71.2293 65.8533 67.4033V44.3034C65.8533 40.4775 62.7358 37.3734 58.8933 37.3734ZM39.1733 59.3184C39.1733 62.509 36.5778 65.0933 33.3733 65.0933C30.1688 65.0933 27.5733 62.509 27.5733 59.3184V52.3884C27.5733 49.1977 30.1688 46.6134 33.3733 46.6134C36.5778 46.6134 39.1733 49.1977 39.1733 52.3884V59.3184Z"
                        fill="white" />
                </svg>
            </div>
            <div class="text-center mt-2">
                <p style="margin-bottom:0;">Activate Pro version</p>
                <a
                    href="<?php printf(esc_html('%sadmin.php?page=settings', 'bulk-mail-sender-pro'), esc_html($admin_url)); ?>">click
                    here</a>
            </div>
        </div>
    </div>

<?php } ?>