<?php
if (!defined('ABSPATH'))
    exit;
$admin_url = get_admin_url();

global $wpdb;
$table_category = $wpdb->prefix . 'bmsi_news_letter_category';
$table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';

$parent_categories = $wpdb->get_results("SELECT * FROM $table_category");

$subcategories = $wpdb->get_results("SELECT * FROM $table_sub_category");

$grouped_subcategories = [];
if (!empty($subcategories)) {
    foreach ($subcategories as $sub) {
        $grouped_subcategories[$sub->parent_category_id][] = $sub;
    }
}

if (!empty($parent_categories)) {
    foreach ($parent_categories as $category) {
        $category->subcategories = isset($grouped_subcategories[$category->id]) ? $grouped_subcategories[$category->id] : [];
    }
}

$is_sub_category = "";
$category_id = "";

if (isset($_GET["edit"]) && $_GET["edit"] == "true") {
    $email_id = !empty($_GET['email_id']) ? sanitize_text_field($_GET['email_id']) : "";

    $news_letters_email = $wpdb->prefix . 'bmsi_news_letters_email';

    $email_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s WHERE id = %d", $news_letters_email, $email_id));

    $tags_data = $email_data[0]->tag;

    
    if (!empty($email_data)) {
        $category_id = $email_data[0]->category;
        $sub_category_id = $email_data[0]->sub_category;
        $category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM {$table_category} WHERE id = %d", $category_id));

        $sub_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM {$table_sub_category} where id = %d", $sub_category_id));
        $is_sub_category = !empty($sub_category_data);

        if ($is_sub_category) {
            $parent_category_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM {$table_category} WHERE id = %d", $sub_category_data[0]->parent_category_id));
        }
    }
}

if (get_option('BMIS_Pro_activated')) {

    ?>

    <div class="ps-70 column-space">
        <div class="pt-4"></div>

        <div class="mb-0 d-lg-flex d-md-flex d-sm-flex d-block justify-content-between title">
            <div class="d-lg-flex d-md-flex d-sm-flex align-items-center gap-2">
                <?php if (isset($_GET['type'])) { ?>
                    <h1 class="fw-bold" style="font-size: 40px;">Contacts Add Email</h1>
                <?php } else { ?>
                    <h1 class="fw-bold" style="font-size: 40px;">Contacts</h1>
                <?php } ?>


                <?php if (!isset($_GET['type']) && !isset($_GET['edit'])) { ?>

                    <a
                        href="<?php printf(esc_html('%sadmin.php?page=email_builder', 'bulk-mail'), esc_html($admin_url)); ?>">
                        <button class="add-button border-0 btn-email">Send Mail</button>
                    </a>
                <?php } ?>

            </div>

            <div>
                <?php if (!isset($_GET['type']) && !isset($_GET['edit'])) { ?>
                    <!-- <button class="add-button border-0 btn-import-email mx-2">Import</button> -->

                    <button class="add-button border-0 btn-import-email mx-2" data-bs-toggle="modal" data-bs-target="#importModal">Import</button>
                    <!-- Modal -->
                    <div class="modal fade" id="importModal" tabindex="-1" aria-labelledby="importModalLabel" aria-hidden="true">
                        <div class="modal-dialog">
                            <div class="modal-content">
                            <div class="modal-header position-relative d-flex justify-content-center align-items-center">
                                <h3 class="modal-title" id="importModalLabel">IMPORT FILE</h3>
                                <button type="button" class="btn-close CloseButton position-absolute right-3" data-bs-dismiss="modal" aria-label="Close" id="CloseButton"></button>
                            </div>
                            <div class="modal-body">
                            <form id="import-form" class="d-flex flex-column gap-2">
                                <div class="form-group position-relative">
                                    <label class="custom-file-label" for="import-file">Choose file</label>
                                    <input type="file" id="import-file" accept=".csv, .xlsx, .json" class="custom-file-input position-absolute" required />
                                    <p class="mt-2 mb-0">Demo File :- <a class="mx-2" href="<?php echo esc_html(BMSI_PRO_DIR_URI) ?>assets/demo/demo.xlsx" download> xlsx</a><a href="<?php echo esc_html(BMSI_PRO_DIR_URI) ?>assets/demo/demo.csv" download> csv</a></p>
                                </div>
                                <div id="fieldsOfImportForm" class="d-none">
                                    <p><b>Note: </b> <span class="text-danger">*</span> Marked Fields are required</p>
                                    <div class="fieldsOfImportForm justify-content-space-between gap-2">
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="first_name">First Name <span class="text-danger">*</span></label>
                                            <select class="w-100 p-2" name="first_name" id="first_name"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="last_name">Last Name <span class="text-danger">*</span></label>
                                            <select class="w-100 p-2" name="last_name" id="last_name"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="email">Email <span class="text-danger">*</span></label>
                                            <select class="w-100 p-2" name="email" id="email"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="job_title">Job Title</label>
                                            <select class="w-100 p-2" name="job_title" id="job_title"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="company">Company</label>
                                            <select class="w-100 p-2" name="company" id="company"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="birthdate">Birthdate</label>
                                            <select class="w-100 p-2" name="birthdate" id="birthdate"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="anniversary">Anniversary</label>
                                            <select class="w-100 p-2" name="anniversary" id="anniversary"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="category">Category</label>
                                            <select class="w-100 p-2" name="category" id="category"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="sub_category">Sub Category</label>
                                            <select class="w-100 p-2" name="sub_category" id="sub_category"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="tags">Tags</label>
                                            <select class="w-100 p-2" name="tags" id="tags"></select>
                                        </div>
                                        <div class="form-group d-flex flex-column gap-1">
                                            <label for="status">Status</label>
                                            <select class="w-100 p-2" name="status" id="status"></select>
                                        </div>
                                    </div>
                                </div>
                            </form>
                            </div>
                            <div class="modal-footer d-flex align-items-center justify-content-center">
                                <button type="button" class="btn btn-secondary CloseButton" data-bs-dismiss="modal" id="CloseButtonFooter">Close</button>
                                <button type="button" class="btn btn-primary" id="ImportButton"><span class="btn-txt">Import </span><i class="fa-solid fa-spinner spinn"></i></button>
                            
                            </div>
                            </div>
                        </div>
                    </div>

                    <input type="hidden" id="site_url" name="site_url" value="<?php echo esc_html(BMSI_PRO_DIR_URI) ?>">
                    <a
                        href="<?php printf(esc_html('%sadmin.php?page=newsletter&type=add_email', 'bulk-mail'), esc_html($admin_url)); ?>">
                        <button class="add-button border-0 btn-email">Add New Contact</button>
                    </a>
                <?php } ?>
            </div>

        </div>

        <?php if ((isset($_GET['type']) && $_GET['type'] === 'add_email') || (isset($_GET['edit']) && $_GET['edit'] === 'true')) {

            $nonce = wp_create_nonce('news_letter_category_nonce');
            ?>

            <form action="#" method="POST" class="new_letter_add_email_category">
                <div id="form_data">
                    <input type="hidden" id="create_user_nonce" name="news_letter_category_nonce"
                        value="<?php echo esc_attr($nonce); ?>" />
                    <div class="pt-4"></div>
                    <div class="form-contant d-flex flex-column w-50">
                        <div class="firstAndLastName">
                            <div class="d-flex flex-column gap-2 mb-3">
                                <label for="news_letter_email"><?php echo isset($_GET['edit']) ? "Edit Email" : "Add Email" ?></label>
                                <input type="email" class="input-groups" name="news_letter_email" id="news_letter_email"
                                    placeholder="Enter Email"
                                    value="<?php echo !empty($email_data[0]->email) ? esc_html($email_data[0]->email) : "" ?>"
                                    required>
                                <input type="hidden" name="email_id" id="email_id"
                                    value="<?php echo !empty($email_id) ? esc_html($email_id) : ""; ?>">
                            </div>
                            <div class="d-flex flex-column gap-2">
                                <label for="category">Contact Category</label>
                                <select  name="category" id="parentcategory" class="input-groups">
                                    <?php
                                    if (!empty($parent_categories)) {
                                        foreach ($parent_categories as $category) {
                                            echo '<option class="' . esc_attr($category->level) . '" value="' . esc_attr($category->id) . '"';

                                            if (isset($_GET["edit"]) && $_GET["edit"] == "true" && $category_id == $category->id) {
                                                echo ' selected';
                                            }

                                            echo '>' . esc_html($category->category_name) . '</option>';

                                            foreach ($category->subcategories as $sub_category) {
                                                echo '<option class="' . esc_attr($sub_category->level) . '" value="' . esc_attr($sub_category->id) . '"';

                                                if (isset($_GET["edit"]) && $_GET["edit"] == "true" && $sub_category_id == $sub_category->id) {
                                                    echo ' selected';
                                                }

                                                echo '>&nbsp;&nbsp;&nbsp;- ' . esc_html($sub_category->sub_category_name) . '</option>';
                                            }
                                        }
                                    } else {
                                        echo '<option class="level-0" name="category" value="uncategory">uncategory</option>';
                                    }
                                    ?>
                                </select>
                            </div>
                            
                            <?php
                                $table_tag = $wpdb->prefix . 'bmsi_news_letter_tag';

                                $tags = $wpdb->get_results("SELECT * FROM $table_tag");

                                $selected_tags = "";
                                if (isset($_GET["edit"]) && $_GET["edit"] == "true") {
                                    $selected_tags = $tags_data ? json_decode($tags_data, true) : "";
                                }


                            ?>

                            <div class=" d-flex flex-column gap-2 w-100 mt-3">
                                <label>Contact Tag</label>
                                <input type="hidden" name="tags_data" id="tags_data" value='<?php echo $tags_data ?? '';?>'>

                                <select name="tags" id="tagsSelect" class="input-groups" multiple>
                                    <?php
                                    foreach ($tags as $tag) {
                                       
                                        $selected = !empty($selected_tags) && in_array($tag->id, $selected_tags) ? 'selected' : '';
                                        echo '<option value="' . esc_html($tag->id) . '" ' . $selected . '>' . esc_html($tag->tags_name) . '</option>';
                                    } ?>
                                </select>
                            </div>

                            <div class="d-flex flex-column gap-2 mt-3">
                                <label for="status">Status</label>
                                <select name="status" id="status" class="input-groups">
                                    <?php
                                    if (!empty($email_data)) {
                                        if (!empty($email_data[0]->status == "1")) { ?>
                                            <option name="status" value="1">Active</option>
                                            <option name="status" value="0">Inactive</option>
                                        <?php } else { ?>
                                            <option name="status" value="0">Inactive</option>
                                            <option name="status" value="1">Active</option>
                                        <?php }
                                    } else { ?>
                                        <option name="status" value="1">Active</option>
                                        <option name="status" value="0">Inactive</option>
                                    <?php } ?>
                                </select>
                            </div>

                            <div class="row d-flex mt-3">
                                <div class="col-md-6 d-flex flex-column gap-2">
                                    <label for="fname">First name</label>
                                    <input type="text" class="input-groups w-100" name="fname" id="fname" value="<?php echo !empty($email_data[0]->fname) ? esc_html($email_data[0]->fname) : "" ?>">
                                </div>
                                <div class="col-md-6 d-flex flex-column gap-2">
                                    <label for="lname">Last name</label>
                                    <input type="text" class="input-groups w-100" name="lname" id="lname" value="<?php echo !empty($email_data[0]->lname) ? esc_html($email_data[0]->lname) : "" ?>">
                                </div>
                            </div>

                            <div class="d-flex flex-column gap-2 mt-3">
                                <label for="job_title">Job Title</label>
                                <input type="text" class="input-groups w-100" name="job_title" id="job_title" value="<?php echo !empty($email_data[0]->job_title) ? esc_html($email_data[0]->job_title) : "" ?>">
                            </div>

                            <div class="d-flex flex-column gap-2 mt-3">
                                <label for="company">Company</label>
                                <input type="text" class="input-groups w-100" name="company" id="company" value="<?php echo !empty($email_data[0]->company) ? esc_html($email_data[0]->company) : "" ?>">
                            </div>

                            <div class="row d-flex mt-3">
                                <div class="col-md-6 d-flex flex-column gap-2">
                                    <label for="birthdate">Birthdate</label>
                                    <input type="date" class="input-groups w-100" name="birthdate" id="birthdate" value="<?php echo !empty($email_data[0]->birthdate) ? esc_html($email_data[0]->birthdate) : "" ?>">
                                </div>
                                <div class="col-md-6 d-flex flex-column gap-2">
                                    <label for="anniversary">Anniversary</label>
                                    <input type="date" class="input-groups w-100" name="anniversary" id="anniversary" value="<?php echo !empty($email_data[0]->anniversary) ? esc_html($email_data[0]->anniversary) : "" ?>">
                                </div>
                            </div>

                        </div>
                    </div>
                    <div class="d-flex justify-content-start mt-3">
                        <button type="submit" name="submit-sub" id="submit"
                            class="add-button fs-16menu border-0 <?php echo (isset($_GET['edit']) && $_GET['edit'] === 'true') ? "btn-news-letter-email-edit" : "btn-news-letter-user" ?> "><span
                                class="btn-new">
                                <?php echo (isset($_GET['edit']) && $_GET['edit'] === 'true') ? "Save" : "Add New Contact" ?>
                            </span><i class="fa-solid fa-spinner spinn"></i></button>
                    </div>
                </div>
            </form>

        <?php } else { ?>

        <div class="wrap">
            <input type="hidden" name="all_users" value="all_user_nonce" />
            <div class="table-wrapper"> </div>

                <div class="filter">
                    <select id="category_filter" class="me-2 mb-2">
                        <option name="category_filter" value="All">— Parent Category —
                        </option>
                        <?php
                        if (!empty($parent_categories)) {
                            foreach ($parent_categories as $key => $value) {
                                ?>
                                <option name="category_filter" value="<?php echo esc_attr($value->id); ?>">
                                    <?php echo esc_attr($value->category_name); ?>
                                </option>
                            <?php }
                        } else { ?>
                            <option name="category_filter" value="uncategory">uncategory
                            </option>
                        <?php } ?>
                    </select>

                    <select id="status_filter" class="me-3 mb-2">
                        <option name="status_filter" value="2">All Status
                        </option>
                        <option name="status_filter" value="1">Active
                        </option>
                        <option name="status_filter" value="0">Inactive
                        </option>
                    </select>
                </div>


                <table id="get_all_email" class="display table">

                    <thead>
                        <tr>
                            <th scope="col" style="text-align:left; padding-left:20px !important;">
                                <?php echo esc_html__("Id", 'bulk-mail'); ?>
                            </th>
                            <th scope="col" style="text-align:left;">
                                <?php echo esc_html__("Email", 'bulk-mail'); ?>
                            </th>
                            <th scope="col" style="text-align:left;">
                                <?php echo esc_html__("Parent Category", 'bulk-mail'); ?>
                            </th>
                            <th scope="col" style="text-align:left;">
                                <?php echo esc_html__("Sub Category", 'bulk-mail'); ?>
                            </th>
                            <th scope="col" style="text-align:left;">
                                <?php echo esc_html__("Tag", 'bulk-mail'); ?>
                            </th>
                            <th scope="col" style="text-align:left;">
                                <?php echo esc_html__("Status", 'bulk-mail'); ?>
                            </th>
                            <th scope="col">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>

        </div>

        <div class="modal fade" id="exampleModal1" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog mt-5">
                <div class="modal-content fs-14">
                    <div class="modal-header">
                        <h5 class="modal-title fs-14 py-2 px-1" id="exampleModalLabel">Email Information</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <div class="id">
                            Id :- <span class="news_letter_id"></span>
                        </div><br>
                        <div class="email">
                            email :- <span class="news_letter_email"></span>
                        </div><br>
                        <div class="category">
                            Parent category :- <span class="news_letter_category"></span>
                        </div><br>
                        <div class="category">
                            Sub category :- <span class="news_letter_subcategory"></span>
                        </div><br>
                        <div class="status">
                            Status :- <span class="news_letter_status"></span>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="fs-14 add-button text-white border-0"
                            data-bs-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>

    <?php } ?>

<?php } else { ?>

    <div class="newsletter-bg-image d-flex justify-content-center align-items-center">
        <div class="dashboard-wrapper">
            <div class="bg-color p-3 rounded-4 mx-5">
                <svg xmlns="http://www.w3.org/2000/svg" width="55" height="55" viewBox="0 0 66 75" fill="none">
                    <path
                        d="M58.8933 37.3734H22.9333V22.4884C22.9333 16.7711 27.5298 12.0212 33.2718 11.9635C39.0718 11.9057 43.8133 16.5979 43.8133 22.3584V24.6684C43.8133 26.5886 45.3648 28.1334 47.2933 28.1334H51.9333C53.8618 28.1334 55.4133 26.5886 55.4133 24.6684V22.3584C55.4133 10.231 45.4808 0.37016 33.3008 0.413472C21.1208 0.456785 11.3333 10.4475 11.3333 22.575V37.3734H7.85331C4.01081 37.3734 0.893311 40.4775 0.893311 44.3034V67.4033C0.893311 71.2293 4.01081 74.3333 7.85331 74.3333H58.8933C62.7358 74.3333 65.8533 71.2293 65.8533 67.4033V44.3034C65.8533 40.4775 62.7358 37.3734 58.8933 37.3734ZM39.1733 59.3184C39.1733 62.509 36.5778 65.0933 33.3733 65.0933C30.1688 65.0933 27.5733 62.509 27.5733 59.3184V52.3884C27.5733 49.1977 30.1688 46.6134 33.3733 46.6134C36.5778 46.6134 39.1733 49.1977 39.1733 52.3884V59.3184Z"
                        fill="white" />
                </svg>
            </div>
            <div class="text-center mt-2">
                <p style="margin-bottom:0;">Activate Pro version</p>
                <a
                    href="<?php printf(esc_html('%sadmin.php?page=settings', 'bulk-mail-sender-pro'), esc_html($admin_url)); ?>">click
                    here</a>
            </div>
        </div>
    </div>

<?php } ?>