<?php

if (!defined('ABSPATH'))
exit;

global $wpdb;
$table_name = $wpdb->prefix . 'bmsi_news_letter_tags';

$data = $wpdb->get_results($wpdb->prepare("SELECT * FROM %1s", $table_name));

if (isset($_GET["edit"]) && $_GET["edit"] == "true" && isset($_GET['tag_id'])) {
$tag = !empty($_GET["tag_id"]) ? $_GET["tag_id"] : "";

global $wpdb;
$table_news_letter_tag = $wpdb->prefix . 'bmsi_news_letter_tag';
$edit_tag = $wpdb->get_results($wpdb->prepare("SELECT `tags_name` FROM %1s WHERE id = %d", $table_news_letter_tag, $tag));
}

if (isset($_GET["edit"]) && $_GET["edit"] == "true" && isset($_GET['sub_tag_id'])) {
$tag = !empty($_GET["sub_tag_id"]) ? $_GET["sub_tag_id"] : "";

global $wpdb;
$table_news_letter_sub_tag = $wpdb->prefix . 'bmsi_news_letter_sub_tag';
$edit_sub_tag = $wpdb->get_results($wpdb->prepare("SELECT `sub_tag_name` FROM %1s WHERE id = %d", $table_news_letter_sub_tag, $tag));
}

if (get_option('BMIS_Pro_activated')) {
?>

<?php require_once (BMSI_DIR_PATH . 'templates/BMSIHeader.php'); ?>

<div class="main ps-70">
    <div class="add-new-users">
        <div class="d-lg-flex d-md-flex d-sm-flex d-block align-items-center justify-content-between gap-3">
            <div class="d-flex flex-row align-items-center gap-3">
                <h1 class="fw-bold" style="font-size: 40px;">Contact Tag</h1>
                <?php if (!isset($_GET["type"]) && !isset($_GET["edit"])) { ?>
                    <a href="<?php printf(esc_html('%sadmin.php?page=newsletter_tags&type=add', 'bulk-mail-sender-pro'), esc_html($admin_url)); ?>"
                        class="add-button border-0 text-decoration-none text-white">Add New Tag</a>
                <?php } ?>
            </div>
        </div>

    </div>
    <?php

    if (isset($_GET["type"]) || isset($_GET["edit"])) {

        $nonce = wp_create_nonce('news_letter_tag_nonce');
        ?>
        <form action="#" method="POST" class="new_letter_add_tag">
            <div id="form_data">
                <input type="hidden" id="create_user_nonce" name="news_letter_tag_nonce"
                    value="<?php echo esc_attr($nonce); ?>" />
                <div class="pt-4"></div>
                <div class="form-contant d-flex ms-0 flex-column">

                    <div class="firstAndLastName">

                        <?php if (isset($_GET['tag_id'])) { ?>

                            <div>
                                <label for="tags">Tag Name</label>
                                <input type="text" class="input-groups" name="tagp" id="tagp"
                                    placeholder="Enter Tag Name"
                                    value="<?php echo !empty($edit_tag[0]->tags_name) ? $edit_tag[0]->tags_name : "" ?>"
                                    required>
                            </div>

                            <input type="hidden" name="tag_type" id="tag_type" value="parenttag">

                        <?php } else {
                            if (isset($_GET['sub_tag_id'])) { ?>

                                <div>
                                    <label for="tags">Tag Name</label>
                                    <input type="text" class="input-groups" name="tags" id="tags"
                                        placeholder="Enter Tag Name"
                                        value="<?php echo !empty($edit_sub_tag[0]->sub_tags_name) ? $edit_sub_tag[0]->sub_tags_name : "" ?>"
                                        required>
                                </div>

                            <?php } else { ?>
                                <div>
                                    <label for="tags">Tag Name</label>
                                    <input type="text" class="input-groups" name="tags" id="tags"
                                        placeholder="Enter Tag Name" required>
                                </div>
                            <?php }
                        } ?>
                        <?php if (isset($_GET["edit"]) && $_GET["edit"] == "true") { ?>
                                <input type="hidden" name="edit_id" id="edit_id"
                                    value="<?php echo isset($_GET["tag_id"]) ? $_GET["tag_id"] : ''; ?>">

                                <input type="hidden" name="edit" id="edit"
                                    value="<?php echo $_GET["edit"] ? $_GET["edit"] : "false"; ?>">
                            <?php } ?>

                    </div>
                    <div class="align-items-start">
                        <button type="submit" name="submit-sub" id="submit"
                            class="add-button fs-16menu border-0 btn-new-tag"><span class="btn-txt">
                                <?php echo ((isset($_GET["edit"]) && $_GET["edit"] == "true")) ? "Update Tag" : "Add New Tag" ?>
                            </span><i class="fa-solid fa-spinner spinn"></i></button>
                    </div>
                </div>
            </div>
        </form>


    <?php } else { ?>

        <div class="wrap pt-2">
            <input type="hidden" id="news_letter_tag_nonce" name="news_letter_tag_nonce"
                value="<?php echo esc_attr($nonce); ?>" />
            <div class="table-wrapper">
                <table id="get_all_news_letters_tags" class="display table">
                    <thead>
                        <tr>
                            <th scope="col" style="text-align:left;padding-left: 18px !important;">
                                <?php echo esc_html__("Tag Name", 'bulk-mail-sender-pro'); ?>
                            </th>
                            <th scope="col" style="text-align:center;">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    <?php } ?>
</div>

<?php } else { ?>

<div class="ntag-bg-image d-flex justify-content-center align-items-center">
    <div class="dashboard-wrapper">
        <div class="bg-color p-3 rounded-4 mx-5">
            <svg xmlns="http://www.w3.org/2000/svg" width="55" height="55" viewBox="0 0 66 75" fill="none">
                <path
                    d="M58.8933 37.3734H22.9333V22.4884C22.9333 16.7711 27.5298 12.0212 33.2718 11.9635C39.0718 11.9057 43.8133 16.5979 43.8133 22.3584V24.6684C43.8133 26.5886 45.3648 28.1334 47.2933 28.1334H51.9333C53.8618 28.1334 55.4133 26.5886 55.4133 24.6684V22.3584C55.4133 10.231 45.4808 0.37016 33.3008 0.413472C21.1208 0.456785 11.3333 10.4475 11.3333 22.575V37.3734H7.85331C4.01081 37.3734 0.893311 40.4775 0.893311 44.3034V67.4033C0.893311 71.2293 4.01081 74.3333 7.85331 74.3333H58.8933C62.7358 74.3333 65.8533 71.2293 65.8533 67.4033V44.3034C65.8533 40.4775 62.7358 37.3734 58.8933 37.3734ZM39.1733 59.3184C39.1733 62.509 36.5778 65.0933 33.3733 65.0933C30.1688 65.0933 27.5733 62.509 27.5733 59.3184V52.3884C27.5733 49.1977 30.1688 46.6134 33.3733 46.6134C36.5778 46.6134 39.1733 49.1977 39.1733 52.3884V59.3184Z"
                    fill="white" />
            </svg>
        </div>
        <div class="text-center mt-2">
            <p style="margin-bottom:0;">Activate Pro version</p>
            <a
                href="<?php printf(esc_html('%sadmin.php?page=settings', 'bulk-mail-sender-pro'), esc_html($admin_url)); ?>">click
                here</a>
        </div>
    </div>
</div>

<?php } ?>